/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Exon_params.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'gnomon.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: Exon_params_.hpp


#ifndef ALGO_GNOMON_EXON_PARAMS_HPP
#define ALGO_GNOMON_EXON_PARAMS_HPP


// generated includes
#include <algo/gnomon/Exon_params_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_XALGOGNOMON_EXPORT CExon_params : public CExon_params_Base
{
    typedef CExon_params_Base Tparent;
public:
    // constructor
    CExon_params(void);
    // destructor
    ~CExon_params(void);

private:
    // Prohibit copy constructor and assignment operator
    CExon_params(const CExon_params& value);
    CExon_params& operator=(const CExon_params& value);

};

/////////////////// CExon_params inline methods

// constructor
inline
CExon_params::CExon_params(void)
{
}


/////////////////// end of CExon_params inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // ALGO_GNOMON_EXON_PARAMS_HPP
/* Original file checksum: lines: 86, chars: 2441, CRC32: 74c82137 */
