/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Length_distribution_params.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'gnomon.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: Length_distribution_params_.hpp


#ifndef ALGO_GNOMON_LENGTH_DISTRIBUTION_PARAMS_HPP
#define ALGO_GNOMON_LENGTH_DISTRIBUTION_PARAMS_HPP


// generated includes
#include <algo/gnomon/Length_distribution_params_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_XALGOGNOMON_EXPORT CLength_distribution_params : public CLength_distribution_params_Base
{
    typedef CLength_distribution_params_Base Tparent;
public:
    // constructor
    CLength_distribution_params(void);
    // destructor
    ~CLength_distribution_params(void);

private:
    // Prohibit copy constructor and assignment operator
    CLength_distribution_params(const CLength_distribution_params& value);
    CLength_distribution_params& operator=(const CLength_distribution_params& value);

};

/////////////////// CLength_distribution_params inline methods

// constructor
inline
CLength_distribution_params::CLength_distribution_params(void)
{
}


/////////////////// end of CLength_distribution_params inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // ALGO_GNOMON_LENGTH_DISTRIBUTION_PARAMS_HPP
/* Original file checksum: lines: 86, chars: 2726, CRC32: f720a84c */
