/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Dataset_derivation_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'pepXML.xsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef ALGO_MS_FORMATS_PEPXML_DATASET_DERIVATION_BASE_HPP
#define ALGO_MS_FORMATS_PEPXML_DATASET_DERIVATION_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CData_filter;


// generated classes

/////////////////////////////////////////////////////////////////////////////
///Source and filtering criteria used to generate dataset 
class NCBI_PEPXML_EXPORT CDataset_derivation_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CDataset_derivation_Base(void);
    // destructor
    virtual ~CDataset_derivation_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class NCBI_PEPXML_EXPORT C_Attlist : public CSerialObject
    {
        typedef CSerialObject Tparent;
    public:
        // constructor
        C_Attlist(void);
        // destructor
        ~C_Attlist(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
        // types
        typedef int TGeneration_no;
    
        // getters
        // setters
    
        /// mandatory
        /// typedef int TGeneration_no
        ///  Check whether the Generation_no data member has been assigned a value.
        bool IsSetGeneration_no(void) const;
        /// Check whether it is safe or not to call GetGeneration_no method.
        bool CanGetGeneration_no(void) const;
        void ResetGeneration_no(void);
        TGeneration_no GetGeneration_no(void) const;
        void SetGeneration_no(TGeneration_no value);
        TGeneration_no& SetGeneration_no(void);
    
        /// Reset the whole object
        void Reset(void);
    
    
    private:
        // Prohibit copy constructor and assignment operator
        C_Attlist(const C_Attlist&);
        C_Attlist& operator=(const C_Attlist&);
    
        // data
        Uint4 m_set_State[1];
        int m_Generation_no;
    };
    // types
    typedef C_Attlist TAttlist;
    typedef list< CRef< CData_filter > > TData_filter;

    // getters
    // setters

    /// mandatory
    /// typedef C_Attlist TAttlist
    ///  Check whether the Attlist data member has been assigned a value.
    bool IsSetAttlist(void) const;
    /// Check whether it is safe or not to call GetAttlist method.
    bool CanGetAttlist(void) const;
    void ResetAttlist(void);
    const TAttlist& GetAttlist(void) const;
    void SetAttlist(TAttlist& value);
    TAttlist& SetAttlist(void);

    /// optional
    /// typedef list< CRef< CData_filter > > TData_filter
    ///  Check whether the Data_filter data member has been assigned a value.
    bool IsSetData_filter(void) const;
    /// Check whether it is safe or not to call GetData_filter method.
    bool CanGetData_filter(void) const;
    void ResetData_filter(void);
    const TData_filter& GetData_filter(void) const;
    TData_filter& SetData_filter(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CDataset_derivation_Base(const CDataset_derivation_Base&);
    CDataset_derivation_Base& operator=(const CDataset_derivation_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TAttlist > m_Attlist;
    list< CRef< CData_filter > > m_Data_filter;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CDataset_derivation_Base::C_Attlist::IsSetGeneration_no(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CDataset_derivation_Base::C_Attlist::CanGetGeneration_no(void) const
{
    return IsSetGeneration_no();
}

inline
void CDataset_derivation_Base::C_Attlist::ResetGeneration_no(void)
{
    m_Generation_no = 0;
    m_set_State[0] &= ~0x3;
}

inline
CDataset_derivation_Base::C_Attlist::TGeneration_no CDataset_derivation_Base::C_Attlist::GetGeneration_no(void) const
{
    if (!CanGetGeneration_no()) {
        ThrowUnassigned(0);
    }
    return m_Generation_no;
}

inline
void CDataset_derivation_Base::C_Attlist::SetGeneration_no(CDataset_derivation_Base::C_Attlist::TGeneration_no value)
{
    m_Generation_no = value;
    m_set_State[0] |= 0x3;
}

inline
CDataset_derivation_Base::C_Attlist::TGeneration_no& CDataset_derivation_Base::C_Attlist::SetGeneration_no(void)
{
#ifdef _DEBUG
    if (!IsSetGeneration_no()) {
        memset(&m_Generation_no,UnassignedByte(),sizeof(m_Generation_no));
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Generation_no;
}

inline
bool CDataset_derivation_Base::IsSetAttlist(void) const
{
    return m_Attlist.NotEmpty();
}

inline
bool CDataset_derivation_Base::CanGetAttlist(void) const
{
    return true;
}

inline
const CDataset_derivation_Base::TAttlist& CDataset_derivation_Base::GetAttlist(void) const
{
    if ( !m_Attlist ) {
        const_cast<CDataset_derivation_Base*>(this)->ResetAttlist();
    }
    return (*m_Attlist);
}

inline
CDataset_derivation_Base::TAttlist& CDataset_derivation_Base::SetAttlist(void)
{
    if ( !m_Attlist ) {
        ResetAttlist();
    }
    return (*m_Attlist);
}

inline
bool CDataset_derivation_Base::IsSetData_filter(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CDataset_derivation_Base::CanGetData_filter(void) const
{
    return true;
}

inline
const CDataset_derivation_Base::TData_filter& CDataset_derivation_Base::GetData_filter(void) const
{
    return m_Data_filter;
}

inline
CDataset_derivation_Base::TData_filter& CDataset_derivation_Base::SetData_filter(void)
{
    m_set_State[0] |= 0x4;
    return m_Data_filter;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // ALGO_MS_FORMATS_PEPXML_DATASET_DERIVATION_BASE_HPP
