/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Libra_result_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'pepXML.xsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef ALGO_MS_FORMATS_PEPXML_LIBRA_RESULT_BASE_HPP
#define ALGO_MS_FORMATS_PEPXML_LIBRA_RESULT_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CIntensity;


// generated classes

/////////////////////////////////////////////////////////////////////////////
///libra quantitation for search hit 
class NCBI_PEPXML_EXPORT CLibra_result_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CLibra_result_Base(void);
    // destructor
    virtual ~CLibra_result_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class NCBI_PEPXML_EXPORT C_Attlist : public CSerialObject
    {
        typedef CSerialObject Tparent;
    public:
        // constructor
        C_Attlist(void);
        // destructor
        ~C_Attlist(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
        // types
        typedef bool TIs_rejected;
    
        // getters
        // setters
    
        /// optional
        /// typedef bool TIs_rejected
        ///  Check whether the Is_rejected data member has been assigned a value.
        bool IsSetIs_rejected(void) const;
        /// Check whether it is safe or not to call GetIs_rejected method.
        bool CanGetIs_rejected(void) const;
        void ResetIs_rejected(void);
        TIs_rejected GetIs_rejected(void) const;
        void SetIs_rejected(TIs_rejected value);
        TIs_rejected& SetIs_rejected(void);
    
        /// Reset the whole object
        void Reset(void);
    
    
    private:
        // Prohibit copy constructor and assignment operator
        C_Attlist(const C_Attlist&);
        C_Attlist& operator=(const C_Attlist&);
    
        // data
        Uint4 m_set_State[1];
        bool m_Is_rejected;
    };
    // types
    typedef C_Attlist TAttlist;
    typedef list< CRef< CIntensity > > TIntensity;

    // getters
    // setters

    /// mandatory
    /// typedef C_Attlist TAttlist
    ///  Check whether the Attlist data member has been assigned a value.
    bool IsSetAttlist(void) const;
    /// Check whether it is safe or not to call GetAttlist method.
    bool CanGetAttlist(void) const;
    void ResetAttlist(void);
    const TAttlist& GetAttlist(void) const;
    void SetAttlist(TAttlist& value);
    TAttlist& SetAttlist(void);

    /// mandatory
    /// typedef list< CRef< CIntensity > > TIntensity
    ///  Check whether the Intensity data member has been assigned a value.
    bool IsSetIntensity(void) const;
    /// Check whether it is safe or not to call GetIntensity method.
    bool CanGetIntensity(void) const;
    void ResetIntensity(void);
    const TIntensity& GetIntensity(void) const;
    TIntensity& SetIntensity(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CLibra_result_Base(const CLibra_result_Base&);
    CLibra_result_Base& operator=(const CLibra_result_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TAttlist > m_Attlist;
    list< CRef< CIntensity > > m_Intensity;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CLibra_result_Base::C_Attlist::IsSetIs_rejected(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CLibra_result_Base::C_Attlist::CanGetIs_rejected(void) const
{
    return IsSetIs_rejected();
}

inline
void CLibra_result_Base::C_Attlist::ResetIs_rejected(void)
{
    m_Is_rejected = 0;
    m_set_State[0] &= ~0x3;
}

inline
CLibra_result_Base::C_Attlist::TIs_rejected CLibra_result_Base::C_Attlist::GetIs_rejected(void) const
{
    if (!CanGetIs_rejected()) {
        ThrowUnassigned(0);
    }
    return m_Is_rejected;
}

inline
void CLibra_result_Base::C_Attlist::SetIs_rejected(CLibra_result_Base::C_Attlist::TIs_rejected value)
{
    m_Is_rejected = value;
    m_set_State[0] |= 0x3;
}

inline
CLibra_result_Base::C_Attlist::TIs_rejected& CLibra_result_Base::C_Attlist::SetIs_rejected(void)
{
#ifdef _DEBUG
    if (!IsSetIs_rejected()) {
        memset(&m_Is_rejected,UnassignedByte(),sizeof(m_Is_rejected));
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Is_rejected;
}

inline
bool CLibra_result_Base::IsSetAttlist(void) const
{
    return m_Attlist.NotEmpty();
}

inline
bool CLibra_result_Base::CanGetAttlist(void) const
{
    return true;
}

inline
const CLibra_result_Base::TAttlist& CLibra_result_Base::GetAttlist(void) const
{
    if ( !m_Attlist ) {
        const_cast<CLibra_result_Base*>(this)->ResetAttlist();
    }
    return (*m_Attlist);
}

inline
CLibra_result_Base::TAttlist& CLibra_result_Base::SetAttlist(void)
{
    if ( !m_Attlist ) {
        ResetAttlist();
    }
    return (*m_Attlist);
}

inline
bool CLibra_result_Base::IsSetIntensity(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CLibra_result_Base::CanGetIntensity(void) const
{
    return true;
}

inline
const CLibra_result_Base::TIntensity& CLibra_result_Base::GetIntensity(void) const
{
    return m_Intensity;
}

inline
CLibra_result_Base::TIntensity& CLibra_result_Base::SetIntensity(void)
{
    m_set_State[0] |= 0x4;
    return m_Intensity;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // ALGO_MS_FORMATS_PEPXML_LIBRA_RESULT_BASE_HPP
