/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Mod_aminoacid_mass_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'pepXML.xsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef ALGO_MS_FORMATS_PEPXML_MOD_AMINOACID_MASS_BASE_HPP
#define ALGO_MS_FORMATS_PEPXML_MOD_AMINOACID_MASS_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
class NCBI_PEPXML_EXPORT CMod_aminoacid_mass_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CMod_aminoacid_mass_Base(void);
    // destructor
    virtual ~CMod_aminoacid_mass_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class NCBI_PEPXML_EXPORT C_Attlist : public CSerialObject
    {
        typedef CSerialObject Tparent;
    public:
        // constructor
        C_Attlist(void);
        // destructor
        ~C_Attlist(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
        // types
        typedef int TPosition;
        typedef double TMass;
    
        // getters
        // setters
    
        /// mandatory
        /// typedef int TPosition
        ///  Check whether the Position data member has been assigned a value.
        bool IsSetPosition(void) const;
        /// Check whether it is safe or not to call GetPosition method.
        bool CanGetPosition(void) const;
        void ResetPosition(void);
        TPosition GetPosition(void) const;
        void SetPosition(TPosition value);
        TPosition& SetPosition(void);
    
        /// mandatory
        /// typedef double TMass
        ///  Check whether the Mass data member has been assigned a value.
        bool IsSetMass(void) const;
        /// Check whether it is safe or not to call GetMass method.
        bool CanGetMass(void) const;
        void ResetMass(void);
        TMass GetMass(void) const;
        void SetMass(TMass value);
        TMass& SetMass(void);
    
        /// Reset the whole object
        void Reset(void);
    
    
    private:
        // Prohibit copy constructor and assignment operator
        C_Attlist(const C_Attlist&);
        C_Attlist& operator=(const C_Attlist&);
    
        // data
        Uint4 m_set_State[1];
        int m_Position;
        double m_Mass;
    };
    // types
    typedef C_Attlist TAttlist;

    // getters
    // setters

    /// mandatory
    /// typedef C_Attlist TAttlist
    ///  Check whether the Attlist data member has been assigned a value.
    bool IsSetAttlist(void) const;
    /// Check whether it is safe or not to call GetAttlist method.
    bool CanGetAttlist(void) const;
    void ResetAttlist(void);
    const TAttlist& GetAttlist(void) const;
    void SetAttlist(TAttlist& value);
    TAttlist& SetAttlist(void);

    /// mandatory
    ///  Check whether the Mod_aminoacid_mass data member has been assigned a value.
    bool IsSetMod_aminoacid_mass(void) const;
    /// Check whether it is safe or not to call GetMod_aminoacid_mass method.
    bool CanGetMod_aminoacid_mass(void) const;
    void ResetMod_aminoacid_mass(void);
    void SetMod_aminoacid_mass(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CMod_aminoacid_mass_Base(const CMod_aminoacid_mass_Base&);
    CMod_aminoacid_mass_Base& operator=(const CMod_aminoacid_mass_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TAttlist > m_Attlist;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CMod_aminoacid_mass_Base::C_Attlist::IsSetPosition(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CMod_aminoacid_mass_Base::C_Attlist::CanGetPosition(void) const
{
    return IsSetPosition();
}

inline
void CMod_aminoacid_mass_Base::C_Attlist::ResetPosition(void)
{
    m_Position = 0;
    m_set_State[0] &= ~0x3;
}

inline
CMod_aminoacid_mass_Base::C_Attlist::TPosition CMod_aminoacid_mass_Base::C_Attlist::GetPosition(void) const
{
    if (!CanGetPosition()) {
        ThrowUnassigned(0);
    }
    return m_Position;
}

inline
void CMod_aminoacid_mass_Base::C_Attlist::SetPosition(CMod_aminoacid_mass_Base::C_Attlist::TPosition value)
{
    m_Position = value;
    m_set_State[0] |= 0x3;
}

inline
CMod_aminoacid_mass_Base::C_Attlist::TPosition& CMod_aminoacid_mass_Base::C_Attlist::SetPosition(void)
{
#ifdef _DEBUG
    if (!IsSetPosition()) {
        memset(&m_Position,UnassignedByte(),sizeof(m_Position));
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Position;
}

inline
bool CMod_aminoacid_mass_Base::C_Attlist::IsSetMass(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CMod_aminoacid_mass_Base::C_Attlist::CanGetMass(void) const
{
    return IsSetMass();
}

inline
void CMod_aminoacid_mass_Base::C_Attlist::ResetMass(void)
{
    m_Mass = 0;
    m_set_State[0] &= ~0xc;
}

inline
CMod_aminoacid_mass_Base::C_Attlist::TMass CMod_aminoacid_mass_Base::C_Attlist::GetMass(void) const
{
    if (!CanGetMass()) {
        ThrowUnassigned(1);
    }
    return m_Mass;
}

inline
void CMod_aminoacid_mass_Base::C_Attlist::SetMass(CMod_aminoacid_mass_Base::C_Attlist::TMass value)
{
    m_Mass = value;
    m_set_State[0] |= 0xc;
}

inline
CMod_aminoacid_mass_Base::C_Attlist::TMass& CMod_aminoacid_mass_Base::C_Attlist::SetMass(void)
{
#ifdef _DEBUG
    if (!IsSetMass()) {
        memset(&m_Mass,UnassignedByte(),sizeof(m_Mass));
    }
#endif
    m_set_State[0] |= 0x4;
    return m_Mass;
}

inline
bool CMod_aminoacid_mass_Base::IsSetAttlist(void) const
{
    return m_Attlist.NotEmpty();
}

inline
bool CMod_aminoacid_mass_Base::CanGetAttlist(void) const
{
    return true;
}

inline
const CMod_aminoacid_mass_Base::TAttlist& CMod_aminoacid_mass_Base::GetAttlist(void) const
{
    if ( !m_Attlist ) {
        const_cast<CMod_aminoacid_mass_Base*>(this)->ResetAttlist();
    }
    return (*m_Attlist);
}

inline
CMod_aminoacid_mass_Base::TAttlist& CMod_aminoacid_mass_Base::SetAttlist(void)
{
    if ( !m_Attlist ) {
        ResetAttlist();
    }
    SetMod_aminoacid_mass();
    return (*m_Attlist);
}

inline
bool CMod_aminoacid_mass_Base::IsSetMod_aminoacid_mass(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CMod_aminoacid_mass_Base::CanGetMod_aminoacid_mass(void) const
{
    return false;
}

inline
void CMod_aminoacid_mass_Base::ResetMod_aminoacid_mass(void)
{
    m_set_State[0] &= ~0xc;
}

inline
void CMod_aminoacid_mass_Base::SetMod_aminoacid_mass(void)
{
    m_set_State[0] |= 0xc;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // ALGO_MS_FORMATS_PEPXML_MOD_AMINOACID_MASS_BASE_HPP
