/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Roc_data_point.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'pepXML.xsd'.
///
/// New methods or data members can be added to it if needed.
/// See also: Roc_data_point_.hpp


#ifndef ALGO_MS_FORMATS_PEPXML_ROC_DATA_POINT_HPP
#define ALGO_MS_FORMATS_PEPXML_ROC_DATA_POINT_HPP


// generated includes
#include <algo/ms/formats/pepxml/Roc_data_point_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_PEPXML_EXPORT CRoc_data_point : public CRoc_data_point_Base
{
    typedef CRoc_data_point_Base Tparent;
public:
    // constructor
    CRoc_data_point(void);
    // destructor
    ~CRoc_data_point(void);

private:
    // Prohibit copy constructor and assignment operator
    CRoc_data_point(const CRoc_data_point& value);
    CRoc_data_point& operator=(const CRoc_data_point& value);

};

/////////////////// CRoc_data_point inline methods

// constructor
inline
CRoc_data_point::CRoc_data_point(void)
{
}


/////////////////// end of CRoc_data_point inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // ALGO_MS_FORMATS_PEPXML_ROC_DATA_POINT_HPP
/* Original file checksum: lines: 86, chars: 2537, CRC32: ef4b9424 */
