/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Search_result_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'pepXML.xsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef ALGO_MS_FORMATS_PEPXML_SEARCH_RESULT_BASE_HPP
#define ALGO_MS_FORMATS_PEPXML_SEARCH_RESULT_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CSearch_hit;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class NCBI_PEPXML_EXPORT CSearch_result_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CSearch_result_Base(void);
    // destructor
    virtual ~CSearch_result_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class NCBI_PEPXML_EXPORT C_Attlist : public CSerialObject
    {
        typedef CSerialObject Tparent;
    public:
        // constructor
        C_Attlist(void);
        // destructor
        ~C_Attlist(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
        // types
        typedef int TSearch_id;
    
        // getters
        // setters
    
        /// optional with default 1
        /// typedef int TSearch_id
        ///  Check whether the Search_id data member has been assigned a value.
        bool IsSetSearch_id(void) const;
        /// Check whether it is safe or not to call GetSearch_id method.
        bool CanGetSearch_id(void) const;
        void ResetSearch_id(void);
        void SetDefaultSearch_id(void);
        TSearch_id GetSearch_id(void) const;
        void SetSearch_id(TSearch_id value);
        TSearch_id& SetSearch_id(void);
    
        /// Reset the whole object
        void Reset(void);
    
    
    private:
        // Prohibit copy constructor and assignment operator
        C_Attlist(const C_Attlist&);
        C_Attlist& operator=(const C_Attlist&);
    
        // data
        Uint4 m_set_State[1];
        int m_Search_id;
    };
    // types
    typedef C_Attlist TAttlist;
    typedef list< CRef< CSearch_hit > > TSearch_hit;

    // getters
    // setters

    /// mandatory
    /// typedef C_Attlist TAttlist
    ///  Check whether the Attlist data member has been assigned a value.
    bool IsSetAttlist(void) const;
    /// Check whether it is safe or not to call GetAttlist method.
    bool CanGetAttlist(void) const;
    void ResetAttlist(void);
    const TAttlist& GetAttlist(void) const;
    void SetAttlist(TAttlist& value);
    TAttlist& SetAttlist(void);

    /// optional
    /// typedef list< CRef< CSearch_hit > > TSearch_hit
    ///  Check whether the Search_hit data member has been assigned a value.
    bool IsSetSearch_hit(void) const;
    /// Check whether it is safe or not to call GetSearch_hit method.
    bool CanGetSearch_hit(void) const;
    void ResetSearch_hit(void);
    const TSearch_hit& GetSearch_hit(void) const;
    TSearch_hit& SetSearch_hit(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CSearch_result_Base(const CSearch_result_Base&);
    CSearch_result_Base& operator=(const CSearch_result_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TAttlist > m_Attlist;
    list< CRef< CSearch_hit > > m_Search_hit;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CSearch_result_Base::C_Attlist::IsSetSearch_id(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CSearch_result_Base::C_Attlist::CanGetSearch_id(void) const
{
    return true;
}

inline
void CSearch_result_Base::C_Attlist::ResetSearch_id(void)
{
    m_Search_id = 1;
    m_set_State[0] &= ~0x3;
}

inline
void CSearch_result_Base::C_Attlist::SetDefaultSearch_id(void)
{
    ResetSearch_id();
    m_set_State[0] |= 0x1;
}

inline
CSearch_result_Base::C_Attlist::TSearch_id CSearch_result_Base::C_Attlist::GetSearch_id(void) const
{
    return m_Search_id;
}

inline
void CSearch_result_Base::C_Attlist::SetSearch_id(CSearch_result_Base::C_Attlist::TSearch_id value)
{
    m_Search_id = value;
    m_set_State[0] |= 0x3;
}

inline
CSearch_result_Base::C_Attlist::TSearch_id& CSearch_result_Base::C_Attlist::SetSearch_id(void)
{
#ifdef _DEBUG
    if (!IsSetSearch_id()) {
        memset(&m_Search_id,UnassignedByte(),sizeof(m_Search_id));
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Search_id;
}

inline
bool CSearch_result_Base::IsSetAttlist(void) const
{
    return m_Attlist.NotEmpty();
}

inline
bool CSearch_result_Base::CanGetAttlist(void) const
{
    return true;
}

inline
const CSearch_result_Base::TAttlist& CSearch_result_Base::GetAttlist(void) const
{
    if ( !m_Attlist ) {
        const_cast<CSearch_result_Base*>(this)->ResetAttlist();
    }
    return (*m_Attlist);
}

inline
CSearch_result_Base::TAttlist& CSearch_result_Base::SetAttlist(void)
{
    if ( !m_Attlist ) {
        ResetAttlist();
    }
    return (*m_Attlist);
}

inline
bool CSearch_result_Base::IsSetSearch_hit(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CSearch_result_Base::CanGetSearch_hit(void) const
{
    return true;
}

inline
const CSearch_result_Base::TSearch_hit& CSearch_result_Base::GetSearch_hit(void) const
{
    return m_Search_hit;
}

inline
CSearch_result_Base::TSearch_hit& CSearch_result_Base::SetSearch_hit(void)
{
    m_set_State[0] |= 0x4;
    return m_Search_hit;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // ALGO_MS_FORMATS_PEPXML_SEARCH_RESULT_BASE_HPP
