/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Sequence_search_constraint_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'pepXML.xsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef ALGO_MS_FORMATS_PEPXML_SEQUENCE_SEARCH_CONSTRAINT_BASE_HPP
#define ALGO_MS_FORMATS_PEPXML_SEQUENCE_SEARCH_CONSTRAINT_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <string>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
///Required amino acid string 
class NCBI_PEPXML_EXPORT CSequence_search_constraint_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CSequence_search_constraint_Base(void);
    // destructor
    virtual ~CSequence_search_constraint_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class NCBI_PEPXML_EXPORT C_Attlist : public CSerialObject
    {
        typedef CSerialObject Tparent;
    public:
        // constructor
        C_Attlist(void);
        // destructor
        ~C_Attlist(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
        // types
        typedef string TSequence;
    
        // getters
        // setters
    
        /// mandatory
        /// typedef string TSequence
        ///  Check whether the Sequence data member has been assigned a value.
        bool IsSetSequence(void) const;
        /// Check whether it is safe or not to call GetSequence method.
        bool CanGetSequence(void) const;
        void ResetSequence(void);
        const TSequence& GetSequence(void) const;
        void SetSequence(const TSequence& value);
        TSequence& SetSequence(void);
    
        /// Reset the whole object
        void Reset(void);
    
    
    private:
        // Prohibit copy constructor and assignment operator
        C_Attlist(const C_Attlist&);
        C_Attlist& operator=(const C_Attlist&);
    
        // data
        Uint4 m_set_State[1];
        string m_Sequence;
    };
    // types
    typedef C_Attlist TAttlist;

    // getters
    // setters

    /// mandatory
    /// typedef C_Attlist TAttlist
    ///  Check whether the Attlist data member has been assigned a value.
    bool IsSetAttlist(void) const;
    /// Check whether it is safe or not to call GetAttlist method.
    bool CanGetAttlist(void) const;
    void ResetAttlist(void);
    const TAttlist& GetAttlist(void) const;
    void SetAttlist(TAttlist& value);
    TAttlist& SetAttlist(void);

    /// mandatory
    ///  Check whether the Sequence_search_constraint data member has been assigned a value.
    bool IsSetSequence_search_constraint(void) const;
    /// Check whether it is safe or not to call GetSequence_search_constraint method.
    bool CanGetSequence_search_constraint(void) const;
    void ResetSequence_search_constraint(void);
    void SetSequence_search_constraint(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CSequence_search_constraint_Base(const CSequence_search_constraint_Base&);
    CSequence_search_constraint_Base& operator=(const CSequence_search_constraint_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TAttlist > m_Attlist;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CSequence_search_constraint_Base::C_Attlist::IsSetSequence(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CSequence_search_constraint_Base::C_Attlist::CanGetSequence(void) const
{
    return IsSetSequence();
}

inline
const CSequence_search_constraint_Base::C_Attlist::TSequence& CSequence_search_constraint_Base::C_Attlist::GetSequence(void) const
{
    if (!CanGetSequence()) {
        ThrowUnassigned(0);
    }
    return m_Sequence;
}

inline
void CSequence_search_constraint_Base::C_Attlist::SetSequence(const CSequence_search_constraint_Base::C_Attlist::TSequence& value)
{
    m_Sequence = value;
    m_set_State[0] |= 0x3;
}

inline
CSequence_search_constraint_Base::C_Attlist::TSequence& CSequence_search_constraint_Base::C_Attlist::SetSequence(void)
{
#ifdef _DEBUG
    if (!IsSetSequence()) {
        m_Sequence = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Sequence;
}

inline
bool CSequence_search_constraint_Base::IsSetAttlist(void) const
{
    return m_Attlist.NotEmpty();
}

inline
bool CSequence_search_constraint_Base::CanGetAttlist(void) const
{
    return true;
}

inline
const CSequence_search_constraint_Base::TAttlist& CSequence_search_constraint_Base::GetAttlist(void) const
{
    if ( !m_Attlist ) {
        const_cast<CSequence_search_constraint_Base*>(this)->ResetAttlist();
    }
    return (*m_Attlist);
}

inline
CSequence_search_constraint_Base::TAttlist& CSequence_search_constraint_Base::SetAttlist(void)
{
    if ( !m_Attlist ) {
        ResetAttlist();
    }
    SetSequence_search_constraint();
    return (*m_Attlist);
}

inline
bool CSequence_search_constraint_Base::IsSetSequence_search_constraint(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CSequence_search_constraint_Base::CanGetSequence_search_constraint(void) const
{
    return false;
}

inline
void CSequence_search_constraint_Base::ResetSequence_search_constraint(void)
{
    m_set_State[0] &= ~0xc;
}

inline
void CSequence_search_constraint_Base::SetSequence_search_constraint(void)
{
    m_set_State[0] |= 0xc;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // ALGO_MS_FORMATS_PEPXML_SEQUENCE_SEARCH_CONSTRAINT_BASE_HPP
