/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Terminal_modification_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'pepXML.xsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef ALGO_MS_FORMATS_PEPXML_TERMINAL_MODIFICATION_BASE_HPP
#define ALGO_MS_FORMATS_PEPXML_TERMINAL_MODIFICATION_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <string>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
///Modification to the N or C terminus, static or variable 
class NCBI_PEPXML_EXPORT CTerminal_modification_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CTerminal_modification_Base(void);
    // destructor
    virtual ~CTerminal_modification_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class NCBI_PEPXML_EXPORT C_Attlist : public CSerialObject
    {
        typedef CSerialObject Tparent;
    public:
        // constructor
        C_Attlist(void);
        // destructor
        ~C_Attlist(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
        // types
        typedef string TTerminus;
        typedef string TMassdiff;
        typedef double TMass;
        typedef string TVariable;
        typedef string TSymbol;
        typedef string TProtein_terminus;
        typedef string TDescription;
    
        // getters
        // setters
    
        /// mandatory
        /// typedef string TTerminus
        ///  Check whether the Terminus data member has been assigned a value.
        bool IsSetTerminus(void) const;
        /// Check whether it is safe or not to call GetTerminus method.
        bool CanGetTerminus(void) const;
        void ResetTerminus(void);
        const TTerminus& GetTerminus(void) const;
        void SetTerminus(const TTerminus& value);
        TTerminus& SetTerminus(void);
    
        /// mandatory
        /// typedef string TMassdiff
        ///  Check whether the Massdiff data member has been assigned a value.
        bool IsSetMassdiff(void) const;
        /// Check whether it is safe or not to call GetMassdiff method.
        bool CanGetMassdiff(void) const;
        void ResetMassdiff(void);
        const TMassdiff& GetMassdiff(void) const;
        void SetMassdiff(const TMassdiff& value);
        TMassdiff& SetMassdiff(void);
    
        /// mandatory
        /// typedef double TMass
        ///  Check whether the Mass data member has been assigned a value.
        bool IsSetMass(void) const;
        /// Check whether it is safe or not to call GetMass method.
        bool CanGetMass(void) const;
        void ResetMass(void);
        TMass GetMass(void) const;
        void SetMass(TMass value);
        TMass& SetMass(void);
    
        /// mandatory
        /// typedef string TVariable
        ///  Check whether the Variable data member has been assigned a value.
        bool IsSetVariable(void) const;
        /// Check whether it is safe or not to call GetVariable method.
        bool CanGetVariable(void) const;
        void ResetVariable(void);
        const TVariable& GetVariable(void) const;
        void SetVariable(const TVariable& value);
        TVariable& SetVariable(void);
    
        /// optional
        /// typedef string TSymbol
        ///  Check whether the Symbol data member has been assigned a value.
        bool IsSetSymbol(void) const;
        /// Check whether it is safe or not to call GetSymbol method.
        bool CanGetSymbol(void) const;
        void ResetSymbol(void);
        const TSymbol& GetSymbol(void) const;
        void SetSymbol(const TSymbol& value);
        TSymbol& SetSymbol(void);
    
        /// mandatory
        /// typedef string TProtein_terminus
        ///  Check whether the Protein_terminus data member has been assigned a value.
        bool IsSetProtein_terminus(void) const;
        /// Check whether it is safe or not to call GetProtein_terminus method.
        bool CanGetProtein_terminus(void) const;
        void ResetProtein_terminus(void);
        const TProtein_terminus& GetProtein_terminus(void) const;
        void SetProtein_terminus(const TProtein_terminus& value);
        TProtein_terminus& SetProtein_terminus(void);
    
        /// optional
        /// typedef string TDescription
        ///  Check whether the Description data member has been assigned a value.
        bool IsSetDescription(void) const;
        /// Check whether it is safe or not to call GetDescription method.
        bool CanGetDescription(void) const;
        void ResetDescription(void);
        const TDescription& GetDescription(void) const;
        void SetDescription(const TDescription& value);
        TDescription& SetDescription(void);
    
        /// Reset the whole object
        void Reset(void);
    
    
    private:
        // Prohibit copy constructor and assignment operator
        C_Attlist(const C_Attlist&);
        C_Attlist& operator=(const C_Attlist&);
    
        // data
        Uint4 m_set_State[1];
        string m_Terminus;
        string m_Massdiff;
        double m_Mass;
        string m_Variable;
        string m_Symbol;
        string m_Protein_terminus;
        string m_Description;
    };
    // types
    typedef C_Attlist TAttlist;

    // getters
    // setters

    /// mandatory
    /// typedef C_Attlist TAttlist
    ///  Check whether the Attlist data member has been assigned a value.
    bool IsSetAttlist(void) const;
    /// Check whether it is safe or not to call GetAttlist method.
    bool CanGetAttlist(void) const;
    void ResetAttlist(void);
    const TAttlist& GetAttlist(void) const;
    void SetAttlist(TAttlist& value);
    TAttlist& SetAttlist(void);

    /// mandatory
    ///  Check whether the Terminal_modification data member has been assigned a value.
    bool IsSetTerminal_modification(void) const;
    /// Check whether it is safe or not to call GetTerminal_modification method.
    bool CanGetTerminal_modification(void) const;
    void ResetTerminal_modification(void);
    void SetTerminal_modification(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CTerminal_modification_Base(const CTerminal_modification_Base&);
    CTerminal_modification_Base& operator=(const CTerminal_modification_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TAttlist > m_Attlist;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CTerminal_modification_Base::C_Attlist::IsSetTerminus(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CTerminal_modification_Base::C_Attlist::CanGetTerminus(void) const
{
    return IsSetTerminus();
}

inline
const CTerminal_modification_Base::C_Attlist::TTerminus& CTerminal_modification_Base::C_Attlist::GetTerminus(void) const
{
    if (!CanGetTerminus()) {
        ThrowUnassigned(0);
    }
    return m_Terminus;
}

inline
void CTerminal_modification_Base::C_Attlist::SetTerminus(const CTerminal_modification_Base::C_Attlist::TTerminus& value)
{
    m_Terminus = value;
    m_set_State[0] |= 0x3;
}

inline
CTerminal_modification_Base::C_Attlist::TTerminus& CTerminal_modification_Base::C_Attlist::SetTerminus(void)
{
#ifdef _DEBUG
    if (!IsSetTerminus()) {
        m_Terminus = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Terminus;
}

inline
bool CTerminal_modification_Base::C_Attlist::IsSetMassdiff(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CTerminal_modification_Base::C_Attlist::CanGetMassdiff(void) const
{
    return IsSetMassdiff();
}

inline
const CTerminal_modification_Base::C_Attlist::TMassdiff& CTerminal_modification_Base::C_Attlist::GetMassdiff(void) const
{
    if (!CanGetMassdiff()) {
        ThrowUnassigned(1);
    }
    return m_Massdiff;
}

inline
void CTerminal_modification_Base::C_Attlist::SetMassdiff(const CTerminal_modification_Base::C_Attlist::TMassdiff& value)
{
    m_Massdiff = value;
    m_set_State[0] |= 0xc;
}

inline
CTerminal_modification_Base::C_Attlist::TMassdiff& CTerminal_modification_Base::C_Attlist::SetMassdiff(void)
{
#ifdef _DEBUG
    if (!IsSetMassdiff()) {
        m_Massdiff = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x4;
    return m_Massdiff;
}

inline
bool CTerminal_modification_Base::C_Attlist::IsSetMass(void) const
{
    return ((m_set_State[0] & 0x30) != 0);
}

inline
bool CTerminal_modification_Base::C_Attlist::CanGetMass(void) const
{
    return IsSetMass();
}

inline
void CTerminal_modification_Base::C_Attlist::ResetMass(void)
{
    m_Mass = 0;
    m_set_State[0] &= ~0x30;
}

inline
CTerminal_modification_Base::C_Attlist::TMass CTerminal_modification_Base::C_Attlist::GetMass(void) const
{
    if (!CanGetMass()) {
        ThrowUnassigned(2);
    }
    return m_Mass;
}

inline
void CTerminal_modification_Base::C_Attlist::SetMass(CTerminal_modification_Base::C_Attlist::TMass value)
{
    m_Mass = value;
    m_set_State[0] |= 0x30;
}

inline
CTerminal_modification_Base::C_Attlist::TMass& CTerminal_modification_Base::C_Attlist::SetMass(void)
{
#ifdef _DEBUG
    if (!IsSetMass()) {
        memset(&m_Mass,UnassignedByte(),sizeof(m_Mass));
    }
#endif
    m_set_State[0] |= 0x10;
    return m_Mass;
}

inline
bool CTerminal_modification_Base::C_Attlist::IsSetVariable(void) const
{
    return ((m_set_State[0] & 0xc0) != 0);
}

inline
bool CTerminal_modification_Base::C_Attlist::CanGetVariable(void) const
{
    return IsSetVariable();
}

inline
const CTerminal_modification_Base::C_Attlist::TVariable& CTerminal_modification_Base::C_Attlist::GetVariable(void) const
{
    if (!CanGetVariable()) {
        ThrowUnassigned(3);
    }
    return m_Variable;
}

inline
void CTerminal_modification_Base::C_Attlist::SetVariable(const CTerminal_modification_Base::C_Attlist::TVariable& value)
{
    m_Variable = value;
    m_set_State[0] |= 0xc0;
}

inline
CTerminal_modification_Base::C_Attlist::TVariable& CTerminal_modification_Base::C_Attlist::SetVariable(void)
{
#ifdef _DEBUG
    if (!IsSetVariable()) {
        m_Variable = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x40;
    return m_Variable;
}

inline
bool CTerminal_modification_Base::C_Attlist::IsSetSymbol(void) const
{
    return ((m_set_State[0] & 0x300) != 0);
}

inline
bool CTerminal_modification_Base::C_Attlist::CanGetSymbol(void) const
{
    return IsSetSymbol();
}

inline
const CTerminal_modification_Base::C_Attlist::TSymbol& CTerminal_modification_Base::C_Attlist::GetSymbol(void) const
{
    if (!CanGetSymbol()) {
        ThrowUnassigned(4);
    }
    return m_Symbol;
}

inline
void CTerminal_modification_Base::C_Attlist::SetSymbol(const CTerminal_modification_Base::C_Attlist::TSymbol& value)
{
    m_Symbol = value;
    m_set_State[0] |= 0x300;
}

inline
CTerminal_modification_Base::C_Attlist::TSymbol& CTerminal_modification_Base::C_Attlist::SetSymbol(void)
{
#ifdef _DEBUG
    if (!IsSetSymbol()) {
        m_Symbol = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x100;
    return m_Symbol;
}

inline
bool CTerminal_modification_Base::C_Attlist::IsSetProtein_terminus(void) const
{
    return ((m_set_State[0] & 0xc00) != 0);
}

inline
bool CTerminal_modification_Base::C_Attlist::CanGetProtein_terminus(void) const
{
    return IsSetProtein_terminus();
}

inline
const CTerminal_modification_Base::C_Attlist::TProtein_terminus& CTerminal_modification_Base::C_Attlist::GetProtein_terminus(void) const
{
    if (!CanGetProtein_terminus()) {
        ThrowUnassigned(5);
    }
    return m_Protein_terminus;
}

inline
void CTerminal_modification_Base::C_Attlist::SetProtein_terminus(const CTerminal_modification_Base::C_Attlist::TProtein_terminus& value)
{
    m_Protein_terminus = value;
    m_set_State[0] |= 0xc00;
}

inline
CTerminal_modification_Base::C_Attlist::TProtein_terminus& CTerminal_modification_Base::C_Attlist::SetProtein_terminus(void)
{
#ifdef _DEBUG
    if (!IsSetProtein_terminus()) {
        m_Protein_terminus = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x400;
    return m_Protein_terminus;
}

inline
bool CTerminal_modification_Base::C_Attlist::IsSetDescription(void) const
{
    return ((m_set_State[0] & 0x3000) != 0);
}

inline
bool CTerminal_modification_Base::C_Attlist::CanGetDescription(void) const
{
    return IsSetDescription();
}

inline
const CTerminal_modification_Base::C_Attlist::TDescription& CTerminal_modification_Base::C_Attlist::GetDescription(void) const
{
    if (!CanGetDescription()) {
        ThrowUnassigned(6);
    }
    return m_Description;
}

inline
void CTerminal_modification_Base::C_Attlist::SetDescription(const CTerminal_modification_Base::C_Attlist::TDescription& value)
{
    m_Description = value;
    m_set_State[0] |= 0x3000;
}

inline
CTerminal_modification_Base::C_Attlist::TDescription& CTerminal_modification_Base::C_Attlist::SetDescription(void)
{
#ifdef _DEBUG
    if (!IsSetDescription()) {
        m_Description = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1000;
    return m_Description;
}

inline
bool CTerminal_modification_Base::IsSetAttlist(void) const
{
    return m_Attlist.NotEmpty();
}

inline
bool CTerminal_modification_Base::CanGetAttlist(void) const
{
    return true;
}

inline
const CTerminal_modification_Base::TAttlist& CTerminal_modification_Base::GetAttlist(void) const
{
    if ( !m_Attlist ) {
        const_cast<CTerminal_modification_Base*>(this)->ResetAttlist();
    }
    return (*m_Attlist);
}

inline
CTerminal_modification_Base::TAttlist& CTerminal_modification_Base::SetAttlist(void)
{
    if ( !m_Attlist ) {
        ResetAttlist();
    }
    SetTerminal_modification();
    return (*m_Attlist);
}

inline
bool CTerminal_modification_Base::IsSetTerminal_modification(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CTerminal_modification_Base::CanGetTerminal_modification(void) const
{
    return false;
}

inline
void CTerminal_modification_Base::ResetTerminal_modification(void)
{
    m_set_State[0] &= ~0xc;
}

inline
void CTerminal_modification_Base::SetTerminal_modification(void)
{
    m_set_State[0] |= 0xc;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // ALGO_MS_FORMATS_PEPXML_TERMINAL_MODIFICATION_BASE_HPP
