/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Xpressratio_summary_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'pepXML.xsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef ALGO_MS_FORMATS_PEPXML_XPRESSRATIO_SUMMARY_BASE_HPP
#define ALGO_MS_FORMATS_PEPXML_XPRESSRATIO_SUMMARY_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <string>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
///Quantitation 
class NCBI_PEPXML_EXPORT CXpressratio_summary_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CXpressratio_summary_Base(void);
    // destructor
    virtual ~CXpressratio_summary_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class NCBI_PEPXML_EXPORT C_Attlist : public CSerialObject
    {
        typedef CSerialObject Tparent;
    public:
        // constructor
        C_Attlist(void);
        // destructor
        ~C_Attlist(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
        // types
        typedef string TVersion;
        typedef string TAuthor;
        typedef string TSame_scan_range;
        typedef string TLabeled_residues;
        typedef int TXpress_light;
        typedef string TMassdiff;
        typedef double TMasstol;
    
        // getters
        // setters
    
        /// mandatory
        /// typedef string TVersion
        ///  Check whether the Version data member has been assigned a value.
        bool IsSetVersion(void) const;
        /// Check whether it is safe or not to call GetVersion method.
        bool CanGetVersion(void) const;
        void ResetVersion(void);
        const TVersion& GetVersion(void) const;
        void SetVersion(const TVersion& value);
        TVersion& SetVersion(void);
    
        /// mandatory
        /// typedef string TAuthor
        ///  Check whether the Author data member has been assigned a value.
        bool IsSetAuthor(void) const;
        /// Check whether it is safe or not to call GetAuthor method.
        bool CanGetAuthor(void) const;
        void ResetAuthor(void);
        const TAuthor& GetAuthor(void) const;
        void SetAuthor(const TAuthor& value);
        TAuthor& SetAuthor(void);
    
        /// mandatory
        /// typedef string TSame_scan_range
        ///  Check whether the Same_scan_range data member has been assigned a value.
        bool IsSetSame_scan_range(void) const;
        /// Check whether it is safe or not to call GetSame_scan_range method.
        bool CanGetSame_scan_range(void) const;
        void ResetSame_scan_range(void);
        const TSame_scan_range& GetSame_scan_range(void) const;
        void SetSame_scan_range(const TSame_scan_range& value);
        TSame_scan_range& SetSame_scan_range(void);
    
        /// mandatory
        /// typedef string TLabeled_residues
        ///  Check whether the Labeled_residues data member has been assigned a value.
        bool IsSetLabeled_residues(void) const;
        /// Check whether it is safe or not to call GetLabeled_residues method.
        bool CanGetLabeled_residues(void) const;
        void ResetLabeled_residues(void);
        const TLabeled_residues& GetLabeled_residues(void) const;
        void SetLabeled_residues(const TLabeled_residues& value);
        TLabeled_residues& SetLabeled_residues(void);
    
        /// mandatory
        /// typedef int TXpress_light
        ///  Check whether the Xpress_light data member has been assigned a value.
        bool IsSetXpress_light(void) const;
        /// Check whether it is safe or not to call GetXpress_light method.
        bool CanGetXpress_light(void) const;
        void ResetXpress_light(void);
        TXpress_light GetXpress_light(void) const;
        void SetXpress_light(TXpress_light value);
        TXpress_light& SetXpress_light(void);
    
        /// mandatory
        /// typedef string TMassdiff
        ///  Check whether the Massdiff data member has been assigned a value.
        bool IsSetMassdiff(void) const;
        /// Check whether it is safe or not to call GetMassdiff method.
        bool CanGetMassdiff(void) const;
        void ResetMassdiff(void);
        const TMassdiff& GetMassdiff(void) const;
        void SetMassdiff(const TMassdiff& value);
        TMassdiff& SetMassdiff(void);
    
        /// mandatory
        /// typedef double TMasstol
        ///  Check whether the Masstol data member has been assigned a value.
        bool IsSetMasstol(void) const;
        /// Check whether it is safe or not to call GetMasstol method.
        bool CanGetMasstol(void) const;
        void ResetMasstol(void);
        TMasstol GetMasstol(void) const;
        void SetMasstol(TMasstol value);
        TMasstol& SetMasstol(void);
    
        /// Reset the whole object
        void Reset(void);
    
    
    private:
        // Prohibit copy constructor and assignment operator
        C_Attlist(const C_Attlist&);
        C_Attlist& operator=(const C_Attlist&);
    
        // data
        Uint4 m_set_State[1];
        string m_Version;
        string m_Author;
        string m_Same_scan_range;
        string m_Labeled_residues;
        int m_Xpress_light;
        string m_Massdiff;
        double m_Masstol;
    };
    // types
    typedef C_Attlist TAttlist;

    // getters
    // setters

    /// mandatory
    /// typedef C_Attlist TAttlist
    ///  Check whether the Attlist data member has been assigned a value.
    bool IsSetAttlist(void) const;
    /// Check whether it is safe or not to call GetAttlist method.
    bool CanGetAttlist(void) const;
    void ResetAttlist(void);
    const TAttlist& GetAttlist(void) const;
    void SetAttlist(TAttlist& value);
    TAttlist& SetAttlist(void);

    /// mandatory
    ///  Check whether the Xpressratio_summary data member has been assigned a value.
    bool IsSetXpressratio_summary(void) const;
    /// Check whether it is safe or not to call GetXpressratio_summary method.
    bool CanGetXpressratio_summary(void) const;
    void ResetXpressratio_summary(void);
    void SetXpressratio_summary(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CXpressratio_summary_Base(const CXpressratio_summary_Base&);
    CXpressratio_summary_Base& operator=(const CXpressratio_summary_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TAttlist > m_Attlist;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CXpressratio_summary_Base::C_Attlist::IsSetVersion(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CXpressratio_summary_Base::C_Attlist::CanGetVersion(void) const
{
    return IsSetVersion();
}

inline
const CXpressratio_summary_Base::C_Attlist::TVersion& CXpressratio_summary_Base::C_Attlist::GetVersion(void) const
{
    if (!CanGetVersion()) {
        ThrowUnassigned(0);
    }
    return m_Version;
}

inline
void CXpressratio_summary_Base::C_Attlist::SetVersion(const CXpressratio_summary_Base::C_Attlist::TVersion& value)
{
    m_Version = value;
    m_set_State[0] |= 0x3;
}

inline
CXpressratio_summary_Base::C_Attlist::TVersion& CXpressratio_summary_Base::C_Attlist::SetVersion(void)
{
#ifdef _DEBUG
    if (!IsSetVersion()) {
        m_Version = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Version;
}

inline
bool CXpressratio_summary_Base::C_Attlist::IsSetAuthor(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CXpressratio_summary_Base::C_Attlist::CanGetAuthor(void) const
{
    return IsSetAuthor();
}

inline
const CXpressratio_summary_Base::C_Attlist::TAuthor& CXpressratio_summary_Base::C_Attlist::GetAuthor(void) const
{
    if (!CanGetAuthor()) {
        ThrowUnassigned(1);
    }
    return m_Author;
}

inline
void CXpressratio_summary_Base::C_Attlist::SetAuthor(const CXpressratio_summary_Base::C_Attlist::TAuthor& value)
{
    m_Author = value;
    m_set_State[0] |= 0xc;
}

inline
CXpressratio_summary_Base::C_Attlist::TAuthor& CXpressratio_summary_Base::C_Attlist::SetAuthor(void)
{
#ifdef _DEBUG
    if (!IsSetAuthor()) {
        m_Author = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x4;
    return m_Author;
}

inline
bool CXpressratio_summary_Base::C_Attlist::IsSetSame_scan_range(void) const
{
    return ((m_set_State[0] & 0x30) != 0);
}

inline
bool CXpressratio_summary_Base::C_Attlist::CanGetSame_scan_range(void) const
{
    return IsSetSame_scan_range();
}

inline
const CXpressratio_summary_Base::C_Attlist::TSame_scan_range& CXpressratio_summary_Base::C_Attlist::GetSame_scan_range(void) const
{
    if (!CanGetSame_scan_range()) {
        ThrowUnassigned(2);
    }
    return m_Same_scan_range;
}

inline
void CXpressratio_summary_Base::C_Attlist::SetSame_scan_range(const CXpressratio_summary_Base::C_Attlist::TSame_scan_range& value)
{
    m_Same_scan_range = value;
    m_set_State[0] |= 0x30;
}

inline
CXpressratio_summary_Base::C_Attlist::TSame_scan_range& CXpressratio_summary_Base::C_Attlist::SetSame_scan_range(void)
{
#ifdef _DEBUG
    if (!IsSetSame_scan_range()) {
        m_Same_scan_range = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x10;
    return m_Same_scan_range;
}

inline
bool CXpressratio_summary_Base::C_Attlist::IsSetLabeled_residues(void) const
{
    return ((m_set_State[0] & 0xc0) != 0);
}

inline
bool CXpressratio_summary_Base::C_Attlist::CanGetLabeled_residues(void) const
{
    return IsSetLabeled_residues();
}

inline
const CXpressratio_summary_Base::C_Attlist::TLabeled_residues& CXpressratio_summary_Base::C_Attlist::GetLabeled_residues(void) const
{
    if (!CanGetLabeled_residues()) {
        ThrowUnassigned(3);
    }
    return m_Labeled_residues;
}

inline
void CXpressratio_summary_Base::C_Attlist::SetLabeled_residues(const CXpressratio_summary_Base::C_Attlist::TLabeled_residues& value)
{
    m_Labeled_residues = value;
    m_set_State[0] |= 0xc0;
}

inline
CXpressratio_summary_Base::C_Attlist::TLabeled_residues& CXpressratio_summary_Base::C_Attlist::SetLabeled_residues(void)
{
#ifdef _DEBUG
    if (!IsSetLabeled_residues()) {
        m_Labeled_residues = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x40;
    return m_Labeled_residues;
}

inline
bool CXpressratio_summary_Base::C_Attlist::IsSetXpress_light(void) const
{
    return ((m_set_State[0] & 0x300) != 0);
}

inline
bool CXpressratio_summary_Base::C_Attlist::CanGetXpress_light(void) const
{
    return IsSetXpress_light();
}

inline
void CXpressratio_summary_Base::C_Attlist::ResetXpress_light(void)
{
    m_Xpress_light = 0;
    m_set_State[0] &= ~0x300;
}

inline
CXpressratio_summary_Base::C_Attlist::TXpress_light CXpressratio_summary_Base::C_Attlist::GetXpress_light(void) const
{
    if (!CanGetXpress_light()) {
        ThrowUnassigned(4);
    }
    return m_Xpress_light;
}

inline
void CXpressratio_summary_Base::C_Attlist::SetXpress_light(CXpressratio_summary_Base::C_Attlist::TXpress_light value)
{
    m_Xpress_light = value;
    m_set_State[0] |= 0x300;
}

inline
CXpressratio_summary_Base::C_Attlist::TXpress_light& CXpressratio_summary_Base::C_Attlist::SetXpress_light(void)
{
#ifdef _DEBUG
    if (!IsSetXpress_light()) {
        memset(&m_Xpress_light,UnassignedByte(),sizeof(m_Xpress_light));
    }
#endif
    m_set_State[0] |= 0x100;
    return m_Xpress_light;
}

inline
bool CXpressratio_summary_Base::C_Attlist::IsSetMassdiff(void) const
{
    return ((m_set_State[0] & 0xc00) != 0);
}

inline
bool CXpressratio_summary_Base::C_Attlist::CanGetMassdiff(void) const
{
    return IsSetMassdiff();
}

inline
const CXpressratio_summary_Base::C_Attlist::TMassdiff& CXpressratio_summary_Base::C_Attlist::GetMassdiff(void) const
{
    if (!CanGetMassdiff()) {
        ThrowUnassigned(5);
    }
    return m_Massdiff;
}

inline
void CXpressratio_summary_Base::C_Attlist::SetMassdiff(const CXpressratio_summary_Base::C_Attlist::TMassdiff& value)
{
    m_Massdiff = value;
    m_set_State[0] |= 0xc00;
}

inline
CXpressratio_summary_Base::C_Attlist::TMassdiff& CXpressratio_summary_Base::C_Attlist::SetMassdiff(void)
{
#ifdef _DEBUG
    if (!IsSetMassdiff()) {
        m_Massdiff = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x400;
    return m_Massdiff;
}

inline
bool CXpressratio_summary_Base::C_Attlist::IsSetMasstol(void) const
{
    return ((m_set_State[0] & 0x3000) != 0);
}

inline
bool CXpressratio_summary_Base::C_Attlist::CanGetMasstol(void) const
{
    return IsSetMasstol();
}

inline
void CXpressratio_summary_Base::C_Attlist::ResetMasstol(void)
{
    m_Masstol = 0;
    m_set_State[0] &= ~0x3000;
}

inline
CXpressratio_summary_Base::C_Attlist::TMasstol CXpressratio_summary_Base::C_Attlist::GetMasstol(void) const
{
    if (!CanGetMasstol()) {
        ThrowUnassigned(6);
    }
    return m_Masstol;
}

inline
void CXpressratio_summary_Base::C_Attlist::SetMasstol(CXpressratio_summary_Base::C_Attlist::TMasstol value)
{
    m_Masstol = value;
    m_set_State[0] |= 0x3000;
}

inline
CXpressratio_summary_Base::C_Attlist::TMasstol& CXpressratio_summary_Base::C_Attlist::SetMasstol(void)
{
#ifdef _DEBUG
    if (!IsSetMasstol()) {
        memset(&m_Masstol,UnassignedByte(),sizeof(m_Masstol));
    }
#endif
    m_set_State[0] |= 0x1000;
    return m_Masstol;
}

inline
bool CXpressratio_summary_Base::IsSetAttlist(void) const
{
    return m_Attlist.NotEmpty();
}

inline
bool CXpressratio_summary_Base::CanGetAttlist(void) const
{
    return true;
}

inline
const CXpressratio_summary_Base::TAttlist& CXpressratio_summary_Base::GetAttlist(void) const
{
    if ( !m_Attlist ) {
        const_cast<CXpressratio_summary_Base*>(this)->ResetAttlist();
    }
    return (*m_Attlist);
}

inline
CXpressratio_summary_Base::TAttlist& CXpressratio_summary_Base::SetAttlist(void)
{
    if ( !m_Attlist ) {
        ResetAttlist();
    }
    SetXpressratio_summary();
    return (*m_Attlist);
}

inline
bool CXpressratio_summary_Base::IsSetXpressratio_summary(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CXpressratio_summary_Base::CanGetXpressratio_summary(void) const
{
    return false;
}

inline
void CXpressratio_summary_Base::ResetXpressratio_summary(void)
{
    m_set_State[0] &= ~0xc;
}

inline
void CXpressratio_summary_Base::SetXpressratio_summary(void)
{
    m_set_State[0] |= 0xc;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // ALGO_MS_FORMATS_PEPXML_XPRESSRATIO_SUMMARY_BASE_HPP
