/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Cdd_Script_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'cdd.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_CDD_CDD_SCRIPT_BASE_HPP
#define OBJECTS_CDD_CDD_SCRIPT_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <string>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
class NCBI_CDD_EXPORT CCdd_Script_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CCdd_Script_Base(void);
    // destructor
    virtual ~CCdd_Script_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    enum EType {
        eType_unassigned       =   0,
        eType_user_recorded    =   1,
        eType_server_generated =   2,
        eType_other            = 255
    };
    
    /// Access to EType's attributes (values, names) as defined in spec
    static const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(EType)(void);
    
    // types
    typedef int TType;
    typedef string TName;
    typedef string TCommands;

    // getters
    // setters

    /// optional
    /// typedef int TType
    ///  Check whether the Type data member has been assigned a value.
    bool IsSetType(void) const;
    /// Check whether it is safe or not to call GetType method.
    bool CanGetType(void) const;
    void ResetType(void);
    TType GetType(void) const;
    void SetType(TType value);
    TType& SetType(void);

    /// user assigned name/description
    /// optional
    /// typedef string TName
    ///  Check whether the Name data member has been assigned a value.
    bool IsSetName(void) const;
    /// Check whether it is safe or not to call GetName method.
    bool CanGetName(void) const;
    void ResetName(void);
    const TName& GetName(void) const;
    void SetName(const TName& value);
    TName& SetName(void);

    /// actual script commands
    /// mandatory
    /// typedef string TCommands
    ///  Check whether the Commands data member has been assigned a value.
    bool IsSetCommands(void) const;
    /// Check whether it is safe or not to call GetCommands method.
    bool CanGetCommands(void) const;
    void ResetCommands(void);
    const TCommands& GetCommands(void) const;
    void SetCommands(const TCommands& value);
    TCommands& SetCommands(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CCdd_Script_Base(const CCdd_Script_Base&);
    CCdd_Script_Base& operator=(const CCdd_Script_Base&);

    // data
    Uint4 m_set_State[1];
    int m_Type;
    string m_Name;
    string m_Commands;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CCdd_Script_Base::IsSetType(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CCdd_Script_Base::CanGetType(void) const
{
    return IsSetType();
}

inline
void CCdd_Script_Base::ResetType(void)
{
    m_Type = (EType)(0);
    m_set_State[0] &= ~0x3;
}

inline
CCdd_Script_Base::TType CCdd_Script_Base::GetType(void) const
{
    if (!CanGetType()) {
        ThrowUnassigned(0);
    }
    return m_Type;
}

inline
void CCdd_Script_Base::SetType(CCdd_Script_Base::TType value)
{
    m_Type = value;
    m_set_State[0] |= 0x3;
}

inline
CCdd_Script_Base::TType& CCdd_Script_Base::SetType(void)
{
#ifdef _DEBUG
    if (!IsSetType()) {
        memset(&m_Type,UnassignedByte(),sizeof(m_Type));
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Type;
}

inline
bool CCdd_Script_Base::IsSetName(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CCdd_Script_Base::CanGetName(void) const
{
    return IsSetName();
}

inline
const CCdd_Script_Base::TName& CCdd_Script_Base::GetName(void) const
{
    if (!CanGetName()) {
        ThrowUnassigned(1);
    }
    return m_Name;
}

inline
void CCdd_Script_Base::SetName(const CCdd_Script_Base::TName& value)
{
    m_Name = value;
    m_set_State[0] |= 0xc;
}

inline
CCdd_Script_Base::TName& CCdd_Script_Base::SetName(void)
{
#ifdef _DEBUG
    if (!IsSetName()) {
        m_Name = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x4;
    return m_Name;
}

inline
bool CCdd_Script_Base::IsSetCommands(void) const
{
    return ((m_set_State[0] & 0x30) != 0);
}

inline
bool CCdd_Script_Base::CanGetCommands(void) const
{
    return IsSetCommands();
}

inline
const CCdd_Script_Base::TCommands& CCdd_Script_Base::GetCommands(void) const
{
    if (!CanGetCommands()) {
        ThrowUnassigned(2);
    }
    return m_Commands;
}

inline
void CCdd_Script_Base::SetCommands(const CCdd_Script_Base::TCommands& value)
{
    m_Commands = value;
    m_set_State[0] |= 0x30;
}

inline
CCdd_Script_Base::TCommands& CCdd_Script_Base::SetCommands(void)
{
#ifdef _DEBUG
    if (!IsSetCommands()) {
        m_Commands = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x10;
    return m_Commands;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_CDD_CDD_SCRIPT_BASE_HPP
