/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file SeqTree_node.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'cdd.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: SeqTree_node_.hpp


#ifndef OBJECTS_CDD_SEQTREE_NODE_HPP
#define OBJECTS_CDD_SEQTREE_NODE_HPP


// generated includes
#include <objects/cdd/SeqTree_node_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_CDD_EXPORT CSeqTree_node : public CSeqTree_node_Base
{
    typedef CSeqTree_node_Base Tparent;
public:
    // constructor
    CSeqTree_node(void);
    // destructor
    ~CSeqTree_node(void);

private:
    // Prohibit copy constructor and assignment operator
    CSeqTree_node(const CSeqTree_node& value);
    CSeqTree_node& operator=(const CSeqTree_node& value);

};

/////////////////// CSeqTree_node inline methods

// constructor
inline
CSeqTree_node::CSeqTree_node(void)
{
}


/////////////////// end of CSeqTree_node inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_CDD_SEQTREE_NODE_HPP
/* Original file checksum: lines: 86, chars: 2449, CRC32: b4388fe4 */
