/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Gene_track.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'entrezgene.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: Gene_track_.hpp


#ifndef OBJECTS_ENTREZGENE_GENE_TRACK_HPP
#define OBJECTS_ENTREZGENE_GENE_TRACK_HPP


// generated includes
#include <objects/entrezgene/Gene_track_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_ENTREZGENE_EXPORT CGene_track : public CGene_track_Base
{
    typedef CGene_track_Base Tparent;
public:
    // constructor
    CGene_track(void);
    // destructor
    ~CGene_track(void);

private:
    // Prohibit copy constructor and assignment operator
    CGene_track(const CGene_track& value);
    CGene_track& operator=(const CGene_track& value);

};

/////////////////// CGene_track inline methods

// constructor
inline
CGene_track::CGene_track(void)
{
}


/////////////////// end of CGene_track inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_ENTREZGENE_GENE_TRACK_HPP
/* Original file checksum: lines: 86, chars: 2453, CRC32: 219acd90 */
