/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Xtra_Terms.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'entrezgene.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: Xtra_Terms_.hpp


#ifndef OBJECTS_ENTREZGENE_XTRA_TERMS_HPP
#define OBJECTS_ENTREZGENE_XTRA_TERMS_HPP


// generated includes
#include <objects/entrezgene/Xtra_Terms_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_ENTREZGENE_EXPORT CXtra_Terms : public CXtra_Terms_Base
{
    typedef CXtra_Terms_Base Tparent;
public:
    // constructor
    CXtra_Terms(void);
    // destructor
    ~CXtra_Terms(void);

private:
    // Prohibit copy constructor and assignment operator
    CXtra_Terms(const CXtra_Terms& value);
    CXtra_Terms& operator=(const CXtra_Terms& value);

};

/////////////////// CXtra_Terms inline methods

// constructor
inline
CXtra_Terms::CXtra_Terms(void)
{
}


/////////////////// end of CXtra_Terms inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_ENTREZGENE_XTRA_TERMS_HPP
/* Original file checksum: lines: 86, chars: 2453, CRC32: 6bc2eb89 */
