/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file GBL_Data.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'genesbyloc.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: GBL_Data_.hpp


#ifndef OBJECTS_GENESBYLOC_GBL_DATA_HPP
#define OBJECTS_GENESBYLOC_GBL_DATA_HPP


// generated includes
#include <objects/genesbyloc/GBL_Data_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_GENESBYLOC_EXPORT CGBL_Data : public CGBL_Data_Base
{
    typedef CGBL_Data_Base Tparent;
public:
    // constructor
    CGBL_Data(void);
    // destructor
    ~CGBL_Data(void);

private:
    // Prohibit copy constructor and assignment operator
    CGBL_Data(const CGBL_Data& value);
    CGBL_Data& operator=(const CGBL_Data& value);

};

/////////////////// CGBL_Data inline methods

// constructor
inline
CGBL_Data::CGBL_Data(void)
{
}


/////////////////// end of CGBL_Data inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_GENESBYLOC_GBL_DATA_HPP
/* Original file checksum: lines: 86, chars: 2415, CRC32: 4ab7aa7e */
