/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file INSDCommentParagraph_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'insdseq.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_INSDSEQ_INSDCOMMENTPARAGRAPH_BASE_HPP
#define OBJECTS_INSDSEQ_INSDCOMMENTPARAGRAPH_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CINSDCommentItem;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class NCBI_INSDSEQ_EXPORT CINSDCommentParagraph_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CINSDCommentParagraph_Base(void);
    // destructor
    virtual ~CINSDCommentParagraph_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef list< CRef< CINSDCommentItem > > TItems;

    // getters
    // setters

    /// mandatory
    /// typedef list< CRef< CINSDCommentItem > > TItems
    ///  Check whether the Items data member has been assigned a value.
    bool IsSetItems(void) const;
    /// Check whether it is safe or not to call GetItems method.
    bool CanGetItems(void) const;
    void ResetItems(void);
    const TItems& GetItems(void) const;
    TItems& SetItems(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CINSDCommentParagraph_Base(const CINSDCommentParagraph_Base&);
    CINSDCommentParagraph_Base& operator=(const CINSDCommentParagraph_Base&);

    // data
    Uint4 m_set_State[1];
    list< CRef< CINSDCommentItem > > m_Items;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CINSDCommentParagraph_Base::IsSetItems(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CINSDCommentParagraph_Base::CanGetItems(void) const
{
    return true;
}

inline
const CINSDCommentParagraph_Base::TItems& CINSDCommentParagraph_Base::GetItems(void) const
{
    return m_Items;
}

inline
CINSDCommentParagraph_Base::TItems& CINSDCommentParagraph_Base::SetItems(void)
{
    m_set_State[0] |= 0x1;
    return m_Items;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_INSDSEQ_INSDCOMMENTPARAGRAPH_BASE_HPP
