/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file CDSGeneProt_field_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'macro.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_MACRO_CDSGENEPROT_FIELD_BASE_HPP
#define OBJECTS_MACRO_CDSGENEPROT_FIELD_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

enum ECDSGeneProt_field {
    eCDSGeneProt_field_cds_comment             =  1,
    eCDSGeneProt_field_gene_locus              =  2,
    eCDSGeneProt_field_gene_description        =  3,
    eCDSGeneProt_field_gene_comment            =  4,
    eCDSGeneProt_field_gene_allele             =  5,
    eCDSGeneProt_field_gene_maploc             =  6,
    eCDSGeneProt_field_gene_locus_tag          =  7,
    eCDSGeneProt_field_gene_synonym            =  8,
    eCDSGeneProt_field_gene_old_locus_tag      =  9,
    eCDSGeneProt_field_mrna_product            = 10,
    eCDSGeneProt_field_mrna_comment            = 11,
    eCDSGeneProt_field_prot_name               = 12,
    eCDSGeneProt_field_prot_description        = 13,
    eCDSGeneProt_field_prot_ec_number          = 14,
    eCDSGeneProt_field_prot_activity           = 15,
    eCDSGeneProt_field_prot_comment            = 16,
    eCDSGeneProt_field_mat_peptide_name        = 17,
    eCDSGeneProt_field_mat_peptide_description = 18,
    eCDSGeneProt_field_mat_peptide_ec_number   = 19,
    eCDSGeneProt_field_mat_peptide_activity    = 20,
    eCDSGeneProt_field_mat_peptide_comment     = 21,
    eCDSGeneProt_field_cds_inference           = 22,
    eCDSGeneProt_field_gene_inference          = 23,
    eCDSGeneProt_field_codon_start             = 24
};

/// Access to ECDSGeneProt_field's attributes (values, names) as defined in spec
 const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(ECDSGeneProt_field)(void);


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_MACRO_CDSGENEPROT_FIELD_BASE_HPP
