/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Feat_qual_legal_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'macro.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_MACRO_FEAT_QUAL_LEGAL_BASE_HPP
#define OBJECTS_MACRO_FEAT_QUAL_LEGAL_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

enum EFeat_qual_legal {
    eFeat_qual_legal_allele                   =  1,
    eFeat_qual_legal_activity                 =  2,
    eFeat_qual_legal_anticodon                =  3,
    eFeat_qual_legal_bound_moiety             =  4,
    eFeat_qual_legal_chromosome               =  5,
    eFeat_qual_legal_citation                 =  6,
    eFeat_qual_legal_codon                    =  7,
    eFeat_qual_legal_codon_start              =  8,
    eFeat_qual_legal_codons_recognized        =  9,
    eFeat_qual_legal_compare                  = 10,
    eFeat_qual_legal_cons_splice              = 11,
    eFeat_qual_legal_db_xref                  = 12,
    eFeat_qual_legal_description              = 13,
    eFeat_qual_legal_direction                = 14,
    eFeat_qual_legal_ec_number                = 15,
    eFeat_qual_legal_environmental_sample     = 16,
    eFeat_qual_legal_evidence                 = 17,
    eFeat_qual_legal_exception                = 18,
    eFeat_qual_legal_experiment               = 19,
    eFeat_qual_legal_focus                    = 20,
    eFeat_qual_legal_frequency                = 21,
    eFeat_qual_legal_function                 = 22,
    eFeat_qual_legal_gene                     = 23,
    eFeat_qual_legal_gene_description         = 24,
    eFeat_qual_legal_inference                = 25,
    eFeat_qual_legal_label                    = 26,
    eFeat_qual_legal_locus_tag                = 27,
    eFeat_qual_legal_map                      = 28,
    eFeat_qual_legal_mobile_element           = 29,
    eFeat_qual_legal_mod_base                 = 30,
    eFeat_qual_legal_mol_type                 = 31,
    eFeat_qual_legal_ncRNA_class              = 32,
    eFeat_qual_legal_note                     = 33,
    eFeat_qual_legal_number                   = 34,
    eFeat_qual_legal_old_locus_tag            = 35,
    eFeat_qual_legal_operon                   = 36,
    eFeat_qual_legal_organism                 = 37,
    eFeat_qual_legal_organelle                = 38,
    eFeat_qual_legal_partial                  = 39,
    eFeat_qual_legal_phenotype                = 40,
    eFeat_qual_legal_plasmid                  = 41,
    eFeat_qual_legal_product                  = 42,
    eFeat_qual_legal_protein_id               = 43,
    eFeat_qual_legal_pseudo                   = 44,
    eFeat_qual_legal_rearranged               = 45,
    eFeat_qual_legal_replace                  = 46,
    eFeat_qual_legal_rpt_family               = 47,
    eFeat_qual_legal_rpt_type                 = 48,
    eFeat_qual_legal_rpt_unit                 = 49,
    eFeat_qual_legal_rpt_unit_seq             = 50,
    eFeat_qual_legal_rpt_unit_range           = 51,
    eFeat_qual_legal_segment                  = 52,
    eFeat_qual_legal_sequenced_mol            = 53,
    eFeat_qual_legal_standard_name            = 54,
    eFeat_qual_legal_synonym                  = 55,
    eFeat_qual_legal_transcript_id            = 56,
    eFeat_qual_legal_transgenic               = 57,
    eFeat_qual_legal_translation              = 58,
    eFeat_qual_legal_transl_except            = 59,
    eFeat_qual_legal_transl_table             = 60,
    eFeat_qual_legal_usedin                   = 61,
    eFeat_qual_legal_mobile_element_type      = 62,
    eFeat_qual_legal_mobile_element_name      = 63,
    eFeat_qual_legal_gene_comment             = 64,
    eFeat_qual_legal_satellite                = 65,
    eFeat_qual_legal_satellite_type           = 66,
    eFeat_qual_legal_satellite_name           = 67,
    eFeat_qual_legal_location                 = 68,
    eFeat_qual_legal_tag_peptide              = 69,
    eFeat_qual_legal_mobile_element_type_type = 70,
    eFeat_qual_legal_name                     = 71,
    eFeat_qual_legal_pcr_conditions           = 72
};

/// Access to EFeat_qual_legal's attributes (values, names) as defined in spec
 const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(EFeat_qual_legal)(void);


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_MACRO_FEAT_QUAL_LEGAL_BASE_HPP
