/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Macro_feature_type_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'macro.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_MACRO_MACRO_FEATURE_TYPE_BASE_HPP
#define OBJECTS_MACRO_MACRO_FEATURE_TYPE_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/// feature values 
enum EMacro_feature_type {
    eMacro_feature_type_any                =  0,
    eMacro_feature_type_gene               =  1,
    eMacro_feature_type_org                =  2,
    eMacro_feature_type_cds                =  3,
    eMacro_feature_type_prot               =  4,
    eMacro_feature_type_preRNA             =  5,
    eMacro_feature_type_mRNA               =  6,
    eMacro_feature_type_tRNA               =  7,
    eMacro_feature_type_rRNA               =  8,
    eMacro_feature_type_snRNA              =  9,
    eMacro_feature_type_scRNA              = 10,
    eMacro_feature_type_otherRNA           = 11,
    eMacro_feature_type_pub                = 12,
    eMacro_feature_type_seq                = 13,
    eMacro_feature_type_imp                = 14,
    eMacro_feature_type_allele             = 15,
    eMacro_feature_type_attenuator         = 16,
    eMacro_feature_type_c_region           = 17,
    eMacro_feature_type_caat_signal        = 18,
    eMacro_feature_type_imp_CDS            = 19,
    eMacro_feature_type_conflict           = 20,
    eMacro_feature_type_d_loop             = 21,
    eMacro_feature_type_d_segment          = 22,
    eMacro_feature_type_enhancer           = 23,
    eMacro_feature_type_exon               = 24,
    eMacro_feature_type_gC_signal          = 25,
    eMacro_feature_type_iDNA               = 26,
    eMacro_feature_type_intron             = 27,
    eMacro_feature_type_j_segment          = 28,
    eMacro_feature_type_ltr                = 29,
    eMacro_feature_type_mat_peptide        = 30,
    eMacro_feature_type_misc_binding       = 31,
    eMacro_feature_type_misc_difference    = 32,
    eMacro_feature_type_misc_feature       = 33,
    eMacro_feature_type_misc_recomb        = 34,
    eMacro_feature_type_misc_RNA           = 35,
    eMacro_feature_type_misc_signal        = 36,
    eMacro_feature_type_misc_structure     = 37,
    eMacro_feature_type_modified_base      = 38,
    eMacro_feature_type_mutation           = 39,
    eMacro_feature_type_n_region           = 40,
    eMacro_feature_type_old_sequence       = 41,
    eMacro_feature_type_polyA_signal       = 42,
    eMacro_feature_type_polyA_site         = 43,
    eMacro_feature_type_precursor_RNA      = 44,
    eMacro_feature_type_prim_transcript    = 45,
    eMacro_feature_type_primer_bind        = 46,
    eMacro_feature_type_promoter           = 47,
    eMacro_feature_type_protein_bind       = 48,
    eMacro_feature_type_rbs                = 49,
    eMacro_feature_type_repeat_region      = 50,
    eMacro_feature_type_rep_origin         = 51,
    eMacro_feature_type_s_region           = 52,
    eMacro_feature_type_sig_peptide        = 53,
    eMacro_feature_type_source             = 54,
    eMacro_feature_type_stem_loop          = 55,
    eMacro_feature_type_sts                = 56,
    eMacro_feature_type_tata_signal        = 57,
    eMacro_feature_type_terminator         = 58,
    eMacro_feature_type_transit_peptide    = 59,
    eMacro_feature_type_unsure             = 60,
    eMacro_feature_type_v_region           = 61,
    eMacro_feature_type_v_segment          = 62,
    eMacro_feature_type_variation          = 63,
    eMacro_feature_type_virion             = 64,
    eMacro_feature_type_n3clip             = 65,
    eMacro_feature_type_n3UTR              = 66,
    eMacro_feature_type_n5clip             = 67,
    eMacro_feature_type_n5UTR              = 68,
    eMacro_feature_type_n10_signal         = 69,
    eMacro_feature_type_n35_signal         = 70,
    eMacro_feature_type_site_ref           = 71,
    eMacro_feature_type_region             = 72,
    eMacro_feature_type_comment            = 73,
    eMacro_feature_type_bond               = 74,
    eMacro_feature_type_site               = 75,
    eMacro_feature_type_rsite              = 76,
    eMacro_feature_type_user               = 77,
    eMacro_feature_type_txinit             = 78,
    eMacro_feature_type_num                = 79,
    eMacro_feature_type_psec_str           = 80,
    eMacro_feature_type_non_std_residue    = 81,
    eMacro_feature_type_het                = 82,
    eMacro_feature_type_biosrc             = 83,
    eMacro_feature_type_preprotein         = 84,
    eMacro_feature_type_mat_peptide_aa     = 85,
    eMacro_feature_type_sig_peptide_aa     = 86,
    eMacro_feature_type_transit_peptide_aa = 87,
    eMacro_feature_type_snoRNA             = 88,
    eMacro_feature_type_gap                = 89,
    eMacro_feature_type_operon             = 90,
    eMacro_feature_type_oriT               = 91,
    eMacro_feature_type_ncRNA              = 92,
    eMacro_feature_type_tmRNA              = 93,
    eMacro_feature_type_mobile_element     = 94
};

/// Access to EMacro_feature_type's attributes (values, names) as defined in spec
 const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(EMacro_feature_type)(void);


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_MACRO_MACRO_FEATURE_TYPE_BASE_HPP
