/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Publication_field_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'macro.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_MACRO_PUBLICATION_FIELD_BASE_HPP
#define OBJECTS_MACRO_PUBLICATION_FIELD_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/// publication fields 
enum EPublication_field {
    ePublication_field_cit              =  1,
    ePublication_field_authors          =  2,
    ePublication_field_journal          =  3,
    ePublication_field_volume           =  4,
    ePublication_field_issue            =  5,
    ePublication_field_pages            =  6,
    ePublication_field_date             =  7,
    ePublication_field_serial_number    =  8,
    ePublication_field_title            =  9,
    ePublication_field_affiliation      = 10,
    ePublication_field_affil_div        = 11,
    ePublication_field_affil_city       = 12,
    ePublication_field_affil_sub        = 13,
    ePublication_field_affil_country    = 14,
    ePublication_field_affil_street     = 15,
    ePublication_field_affil_email      = 16,
    ePublication_field_affil_fax        = 17,
    ePublication_field_affil_phone      = 18,
    ePublication_field_affil_zipcode    = 19,
    ePublication_field_authors_initials = 20,
    ePublication_field_pmid             = 21,
    ePublication_field_pub_class        = 22
};

/// Access to EPublication_field's attributes (values, names) as defined in spec
 const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(EPublication_field)(void);


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_MACRO_PUBLICATION_FIELD_BASE_HPP
