/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Site_type_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'macro.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_MACRO_SITE_TYPE_BASE_HPP
#define OBJECTS_MACRO_SITE_TYPE_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

enum ESite_type {
    eSite_type_active                      =  1,
    eSite_type_binding                     =  2,
    eSite_type_cleavage                    =  3,
    eSite_type_inhibit                     =  4,
    eSite_type_modified                    =  5,
    eSite_type_glycosylation               =  6,
    eSite_type_myristoylation              =  7,
    eSite_type_mutagenized                 =  8,
    eSite_type_metal_binding               =  9,
    eSite_type_phosphorylation             = 10,
    eSite_type_acetylation                 = 11,
    eSite_type_amidation                   = 12,
    eSite_type_methylation                 = 13,
    eSite_type_hydroxylation               = 14,
    eSite_type_sulfatation                 = 15,
    eSite_type_oxidative_deamination       = 16,
    eSite_type_pyrrolidone_carboxylic_acid = 17,
    eSite_type_gamma_carboxyglutamic_acid  = 18,
    eSite_type_blocked                     = 19,
    eSite_type_lipid_binding               = 20,
    eSite_type_np_binding                  = 21,
    eSite_type_dna_binding                 = 22,
    eSite_type_signal_peptide              = 23,
    eSite_type_transit_peptide             = 24,
    eSite_type_transmembrane_region        = 25,
    eSite_type_nitrosylation               = 26,
    eSite_type_other                       = 27
};

/// Access to ESite_type's attributes (values, names) as defined in spec
 const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(ESite_type)(void);


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_MACRO_SITE_TYPE_BASE_HPP
