/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Source_location_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'macro.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_MACRO_SOURCE_LOCATION_BASE_HPP
#define OBJECTS_MACRO_SOURCE_LOCATION_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

enum ESource_location {
    eSource_location_unknown          =  0,
    eSource_location_genomic          =  1,
    eSource_location_chloroplast      =  2,
    eSource_location_chromoplast      =  3,
    eSource_location_kinetoplast      =  4,
    eSource_location_mitochondrion    =  5,
    eSource_location_plastid          =  6,
    eSource_location_macronuclear     =  7,
    eSource_location_extrachrom       =  8,
    eSource_location_plasmid          =  9,
    eSource_location_transposon       = 10,
    eSource_location_insertion_seq    = 11,
    eSource_location_cyanelle         = 12,
    eSource_location_proviral         = 13,
    eSource_location_virion           = 14,
    eSource_location_nucleomorph      = 15,
    eSource_location_apicoplast       = 16,
    eSource_location_leucoplast       = 17,
    eSource_location_proplastid       = 18,
    eSource_location_endogenous_virus = 19,
    eSource_location_hydrogenosome    = 20,
    eSource_location_chromosome       = 21,
    eSource_location_chromatophore    = 22
};

/// Access to ESource_location's attributes (values, names) as defined in spec
 const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(ESource_location)(void);


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_MACRO_SOURCE_LOCATION_BASE_HPP
