/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Mla_back.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'mla.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: Mla_back_.hpp


#ifndef OBJECTS_MLA_MLA_BACK_HPP
#define OBJECTS_MLA_MLA_BACK_HPP


// generated includes
#include <objects/mla/Mla_back_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_MLA_EXPORT CMla_back : public CMla_back_Base
{
    typedef CMla_back_Base Tparent;
public:
    // constructor
    CMla_back(void);
    // destructor
    ~CMla_back(void);

private:
    // Prohibit copy constructor and assignment operator
    CMla_back(const CMla_back& value);
    CMla_back& operator=(const CMla_back& value);

};

/////////////////// CMla_back inline methods

// constructor
inline
CMla_back::CMla_back(void)
{
}


/////////////////// end of CMla_back inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_MLA_MLA_BACK_HPP
/* Original file checksum: lines: 86, chars: 2373, CRC32: 1615fdce */
