/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Atomic_temperature_factors_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'mmdb2.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_MMDB2_ATOMIC_TEMPERATURE_FACTORS_BASE_HPP
#define OBJECTS_MMDB2_ATOMIC_TEMPERATURE_FACTORS_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CAnisotropic_temperature_factors;
class CIsotropic_temperature_factors;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class NCBI_MMDB2_EXPORT CAtomic_temperature_factors_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CAtomic_temperature_factors_Base(void);
    // destructor
    virtual ~CAtomic_temperature_factors_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();


    /// Choice variants.
    enum E_Choice {
        e_not_set = 0,  ///< No variant selected
        e_Isotropic,
        e_Anisotropic
    };
    /// Maximum+1 value of the choice variant enumerator.
    enum E_ChoiceStopper {
        e_MaxChoice = 3 ///< == e_Anisotropic+1
    };

    /// Reset the whole object
    virtual void Reset(void);

    /// Reset the selection (set it to e_not_set).
    virtual void ResetSelection(void);

    /// Which variant is currently selected.
    E_Choice Which(void) const;

    /// Verify selection, throw exception if it differs from the expected.
    void CheckSelected(E_Choice index) const;

    /// Throw 'InvalidSelection' exception.
    NCBI_NORETURN void ThrowInvalidSelection(E_Choice index) const;

    /// Retrieve selection name (for diagnostic purposes).
    static string SelectionName(E_Choice index);

    /// Select the requested variant if needed.
    void Select(E_Choice index, EResetVariant reset = eDoResetVariant);
    /// Select the requested variant if needed,
    /// allocating CObject variants from memory pool.
    void Select(E_Choice index,
                EResetVariant reset,
                CObjectMemoryPool* pool);

    // types
    typedef CIsotropic_temperature_factors TIsotropic;
    typedef CAnisotropic_temperature_factors TAnisotropic;

    // getters
    // setters

    // typedef CIsotropic_temperature_factors TIsotropic
    bool IsIsotropic(void) const;
    const TIsotropic& GetIsotropic(void) const;
    TIsotropic& SetIsotropic(void);
    void SetIsotropic(TIsotropic& value);

    // typedef CAnisotropic_temperature_factors TAnisotropic
    bool IsAnisotropic(void) const;
    const TAnisotropic& GetAnisotropic(void) const;
    TAnisotropic& SetAnisotropic(void);
    void SetAnisotropic(TAnisotropic& value);


private:
    // copy constructor and assignment operator
    CAtomic_temperature_factors_Base(const CAtomic_temperature_factors_Base& );
    CAtomic_temperature_factors_Base& operator=(const CAtomic_temperature_factors_Base& );
    // choice state
    E_Choice m_choice;
    // helper methods
    void DoSelect(E_Choice index, CObjectMemoryPool* pool = 0);

    static const char* const sm_SelectionNames[];
    // data
    NCBI_NS_NCBI::CSerialObject *m_object;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
CAtomic_temperature_factors_Base::E_Choice CAtomic_temperature_factors_Base::Which(void) const
{
    return m_choice;
}

inline
void CAtomic_temperature_factors_Base::CheckSelected(E_Choice index) const
{
    if ( m_choice != index )
        ThrowInvalidSelection(index);
}

inline
void CAtomic_temperature_factors_Base::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset, NCBI_NS_NCBI::CObjectMemoryPool* pool)
{
    if ( reset == NCBI_NS_NCBI::eDoResetVariant || m_choice != index ) {
        if ( m_choice != e_not_set )
            ResetSelection();
        DoSelect(index, pool);
    }
}

inline
void CAtomic_temperature_factors_Base::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset)
{
    Select(index, reset, 0);
}

inline
bool CAtomic_temperature_factors_Base::IsIsotropic(void) const
{
    return m_choice == e_Isotropic;
}

inline
bool CAtomic_temperature_factors_Base::IsAnisotropic(void) const
{
    return m_choice == e_Anisotropic;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_MMDB2_ATOMIC_TEMPERATURE_FACTORS_BASE_HPP
