/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Conformation_ensemble.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'mmdb2.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: Conformation_ensemble_.hpp


#ifndef OBJECTS_MMDB2_CONFORMATION_ENSEMBLE_HPP
#define OBJECTS_MMDB2_CONFORMATION_ENSEMBLE_HPP


// generated includes
#include <objects/mmdb2/Conformation_ensemble_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_MMDB2_EXPORT CConformation_ensemble : public CConformation_ensemble_Base
{
    typedef CConformation_ensemble_Base Tparent;
public:
    // constructor
    CConformation_ensemble(void);
    // destructor
    ~CConformation_ensemble(void);

private:
    // Prohibit copy constructor and assignment operator
    CConformation_ensemble(const CConformation_ensemble& value);
    CConformation_ensemble& operator=(const CConformation_ensemble& value);

};

/////////////////// CConformation_ensemble inline methods

// constructor
inline
CConformation_ensemble::CConformation_ensemble(void)
{
}


/////////////////// end of CConformation_ensemble inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_MMDB2_CONFORMATION_ENSEMBLE_HPP
/* Original file checksum: lines: 86, chars: 2632, CRC32: 8af9a986 */
