/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file RealValue_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'mmdb3.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_MMDB3_REALVALUE_BASE_HPP
#define OBJECTS_MMDB3_REALVALUE_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
class NCBI_MMDB3_EXPORT CRealValue_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CRealValue_Base(void);
    // destructor
    virtual ~CRealValue_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef int TScale_factor;
    typedef int TScaled_integer_value;

    // getters
    // setters

    /// mandatory
    /// typedef int TScale_factor
    ///  Check whether the Scale_factor data member has been assigned a value.
    bool IsSetScale_factor(void) const;
    /// Check whether it is safe or not to call GetScale_factor method.
    bool CanGetScale_factor(void) const;
    void ResetScale_factor(void);
    TScale_factor GetScale_factor(void) const;
    void SetScale_factor(TScale_factor value);
    TScale_factor& SetScale_factor(void);

    /// mandatory
    /// typedef int TScaled_integer_value
    ///  Check whether the Scaled_integer_value data member has been assigned a value.
    bool IsSetScaled_integer_value(void) const;
    /// Check whether it is safe or not to call GetScaled_integer_value method.
    bool CanGetScaled_integer_value(void) const;
    void ResetScaled_integer_value(void);
    TScaled_integer_value GetScaled_integer_value(void) const;
    void SetScaled_integer_value(TScaled_integer_value value);
    TScaled_integer_value& SetScaled_integer_value(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CRealValue_Base(const CRealValue_Base&);
    CRealValue_Base& operator=(const CRealValue_Base&);

    // data
    Uint4 m_set_State[1];
    int m_Scale_factor;
    int m_Scaled_integer_value;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CRealValue_Base::IsSetScale_factor(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CRealValue_Base::CanGetScale_factor(void) const
{
    return IsSetScale_factor();
}

inline
void CRealValue_Base::ResetScale_factor(void)
{
    m_Scale_factor = 0;
    m_set_State[0] &= ~0x3;
}

inline
CRealValue_Base::TScale_factor CRealValue_Base::GetScale_factor(void) const
{
    if (!CanGetScale_factor()) {
        ThrowUnassigned(0);
    }
    return m_Scale_factor;
}

inline
void CRealValue_Base::SetScale_factor(CRealValue_Base::TScale_factor value)
{
    m_Scale_factor = value;
    m_set_State[0] |= 0x3;
}

inline
CRealValue_Base::TScale_factor& CRealValue_Base::SetScale_factor(void)
{
#ifdef _DEBUG
    if (!IsSetScale_factor()) {
        memset(&m_Scale_factor,UnassignedByte(),sizeof(m_Scale_factor));
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Scale_factor;
}

inline
bool CRealValue_Base::IsSetScaled_integer_value(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CRealValue_Base::CanGetScaled_integer_value(void) const
{
    return IsSetScaled_integer_value();
}

inline
void CRealValue_Base::ResetScaled_integer_value(void)
{
    m_Scaled_integer_value = 0;
    m_set_State[0] &= ~0xc;
}

inline
CRealValue_Base::TScaled_integer_value CRealValue_Base::GetScaled_integer_value(void) const
{
    if (!CanGetScaled_integer_value()) {
        ThrowUnassigned(1);
    }
    return m_Scaled_integer_value;
}

inline
void CRealValue_Base::SetScaled_integer_value(CRealValue_Base::TScaled_integer_value value)
{
    m_Scaled_integer_value = value;
    m_set_State[0] |= 0xc;
}

inline
CRealValue_Base::TScaled_integer_value& CRealValue_Base::SetScaled_integer_value(void)
{
#ifdef _DEBUG
    if (!IsSetScaled_integer_value()) {
        memset(&m_Scaled_integer_value,UnassignedByte(),sizeof(m_Scaled_integer_value));
    }
#endif
    m_set_State[0] |= 0x4;
    return m_Scaled_integer_value;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_MMDB3_REALVALUE_BASE_HPP
