/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Residue_interval_pntr.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'mmdb3.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: Residue_interval_pntr_.hpp


#ifndef OBJECTS_MMDB3_RESIDUE_INTERVAL_PNTR_HPP
#define OBJECTS_MMDB3_RESIDUE_INTERVAL_PNTR_HPP


// generated includes
#include <objects/mmdb3/Residue_interval_pntr_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_MMDB3_EXPORT CResidue_interval_pntr : public CResidue_interval_pntr_Base
{
    typedef CResidue_interval_pntr_Base Tparent;
public:
    // constructor
    CResidue_interval_pntr(void);
    // destructor
    ~CResidue_interval_pntr(void);

private:
    // Prohibit copy constructor and assignment operator
    CResidue_interval_pntr(const CResidue_interval_pntr& value);
    CResidue_interval_pntr& operator=(const CResidue_interval_pntr& value);

};

/////////////////// CResidue_interval_pntr inline methods

// constructor
inline
CResidue_interval_pntr::CResidue_interval_pntr(void)
{
}


/////////////////// end of CResidue_interval_pntr inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_MMDB3_RESIDUE_INTERVAL_PNTR_HPP
/* Original file checksum: lines: 86, chars: 2632, CRC32: 79139a91 */
