/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Biostruc_seq.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'ncbimime.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: Biostruc_seq_.hpp


#ifndef OBJECTS_NCBIMIME_BIOSTRUC_SEQ_HPP
#define OBJECTS_NCBIMIME_BIOSTRUC_SEQ_HPP


// generated includes
#include <objects/ncbimime/Biostruc_seq_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_NCBIMIME_EXPORT CBiostruc_seq : public CBiostruc_seq_Base
{
    typedef CBiostruc_seq_Base Tparent;
public:
    // constructor
    CBiostruc_seq(void);
    // destructor
    ~CBiostruc_seq(void);

private:
    // Prohibit copy constructor and assignment operator
    CBiostruc_seq(const CBiostruc_seq& value);
    CBiostruc_seq& operator=(const CBiostruc_seq& value);

};

/////////////////// CBiostruc_seq inline methods

// constructor
inline
CBiostruc_seq::CBiostruc_seq(void)
{
}


/////////////////// end of CBiostruc_seq inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_NCBIMIME_BIOSTRUC_SEQ_HPP
/* Original file checksum: lines: 86, chars: 2479, CRC32: 9c6207da */
