/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Entrez_general.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'ncbimime.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: Entrez_general_.hpp


#ifndef OBJECTS_NCBIMIME_ENTREZ_GENERAL_HPP
#define OBJECTS_NCBIMIME_ENTREZ_GENERAL_HPP


// generated includes
#include <objects/ncbimime/Entrez_general_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_NCBIMIME_EXPORT CEntrez_general : public CEntrez_general_Base
{
    typedef CEntrez_general_Base Tparent;
public:
    // constructor
    CEntrez_general(void);
    // destructor
    ~CEntrez_general(void);

private:
    // Prohibit copy constructor and assignment operator
    CEntrez_general(const CEntrez_general& value);
    CEntrez_general& operator=(const CEntrez_general& value);

};

/////////////////// CEntrez_general inline methods

// constructor
inline
CEntrez_general::CEntrez_general(void)
{
}


/////////////////// end of CEntrez_general inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_NCBIMIME_ENTREZ_GENERAL_HPP
/* Original file checksum: lines: 86, chars: 2517, CRC32: 8a10de90 */
