/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Entrez_style_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'ncbimime.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_NCBIMIME_ENTREZ_STYLE_BASE_HPP
#define OBJECTS_NCBIMIME_ENTREZ_STYLE_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

enum EEntrez_style {
    eEntrez_style_docsum     =  1,
    eEntrez_style_genbank    =  2,
    eEntrez_style_genpept    =  3,
    eEntrez_style_fasta      =  4,
    eEntrez_style_asn1       =  5,
    eEntrez_style_graphic    =  6,
    eEntrez_style_alignment  =  7,
    eEntrez_style_globalview =  8,
    eEntrez_style_report     =  9,
    eEntrez_style_medlars    = 10,
    eEntrez_style_embl       = 11,
    eEntrez_style_pdb        = 12,
    eEntrez_style_kinemage   = 13
};

/// Access to EEntrez_style's attributes (values, names) as defined in spec
NCBI_NCBIMIME_EXPORT const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(EEntrez_style)(void);


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_NCBIMIME_ENTREZ_STYLE_BASE_HPP
