/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file TMgr_AttrRequest_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'trackmgr.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_TRACKMGR_TMGR_ATTRREQUEST_BASE_HPP
#define OBJECTS_TRACKMGR_TMGR_ATTRREQUEST_BASE_HPP

// extra headers
#include <objects/trackmgr/trackmgr_export.h>

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>
#include <string>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
class NCBI_TRACKMGR_EXPORT CTMgr_AttrRequest_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CTMgr_AttrRequest_Base(void);
    // destructor
    virtual ~CTMgr_AttrRequest_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();


    /// Choice variants.
    enum E_Choice {
        e_not_set = 0,      ///< No variant selected
        e_All_attrs,        ///< request all attributes
        e_Track_type_list   ///< request attributes associated  with track types in list
    };
    /// Maximum+1 value of the choice variant enumerator.
    enum E_ChoiceStopper {
        e_MaxChoice = 3 ///< == e_Track_type_list+1
    };

    /// Reset the whole object
    virtual void Reset(void);

    /// Reset the selection (set it to e_not_set).
    virtual void ResetSelection(void);

    /// Which variant is currently selected.
    E_Choice Which(void) const;

    /// Verify selection, throw exception if it differs from the expected.
    void CheckSelected(E_Choice index) const;

    /// Throw 'InvalidSelection' exception.
    NCBI_NORETURN void ThrowInvalidSelection(E_Choice index) const;

    /// Retrieve selection name (for diagnostic purposes).
    static string SelectionName(E_Choice index);

    /// Select the requested variant if needed.
    void Select(E_Choice index, EResetVariant reset = eDoResetVariant);
    /// Select the requested variant if needed,
    /// allocating CObject variants from memory pool.
    void Select(E_Choice index,
                EResetVariant reset,
                CObjectMemoryPool* pool);

    // types
    typedef list< string > TTrack_type_list;

    // getters
    // setters


    bool IsAll_attrs(void) const;
    void SetAll_attrs(void);

    // typedef list< string > TTrack_type_list
    bool IsTrack_type_list(void) const;
    const TTrack_type_list& GetTrack_type_list(void) const;
    TTrack_type_list& SetTrack_type_list(void);


private:
    // copy constructor and assignment operator
    CTMgr_AttrRequest_Base(const CTMgr_AttrRequest_Base& );
    CTMgr_AttrRequest_Base& operator=(const CTMgr_AttrRequest_Base& );
    // choice state
    E_Choice m_choice;
    // helper methods
    void DoSelect(E_Choice index, CObjectMemoryPool* pool = 0);

    static const char* const sm_SelectionNames[];
    // data
    union {
        NCBI_NS_NCBI::CUnionBuffer<TTrack_type_list> m_Track_type_list;
        void* m_dummy_pointer_for_alignment;
    };
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
CTMgr_AttrRequest_Base::E_Choice CTMgr_AttrRequest_Base::Which(void) const
{
    return m_choice;
}

inline
void CTMgr_AttrRequest_Base::CheckSelected(E_Choice index) const
{
    if ( m_choice != index )
        ThrowInvalidSelection(index);
}

inline
void CTMgr_AttrRequest_Base::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset, NCBI_NS_NCBI::CObjectMemoryPool* pool)
{
    if ( reset == NCBI_NS_NCBI::eDoResetVariant || m_choice != index ) {
        if ( m_choice != e_not_set )
            ResetSelection();
        DoSelect(index, pool);
    }
}

inline
void CTMgr_AttrRequest_Base::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset)
{
    Select(index, reset, 0);
}

inline
bool CTMgr_AttrRequest_Base::IsAll_attrs(void) const
{
    return m_choice == e_All_attrs;
}

inline
void CTMgr_AttrRequest_Base::SetAll_attrs(void)
{
    Select(e_All_attrs, NCBI_NS_NCBI::eDoNotResetVariant);
}

inline
bool CTMgr_AttrRequest_Base::IsTrack_type_list(void) const
{
    return m_choice == e_Track_type_list;
}

inline
const CTMgr_AttrRequest_Base::TTrack_type_list& CTMgr_AttrRequest_Base::GetTrack_type_list(void) const
{
    CheckSelected(e_Track_type_list);
    return *m_Track_type_list;
}

inline
CTMgr_AttrRequest_Base::TTrack_type_list& CTMgr_AttrRequest_Base::SetTrack_type_list(void)
{
    Select(e_Track_type_list, NCBI_NS_NCBI::eDoNotResetVariant);
    return *m_Track_type_list;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_TRACKMGR_TMGR_ATTRREQUEST_BASE_HPP
