/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file TMgr_DisplayTrackRequest_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'trackmgr.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_TRACKMGR_TMGR_DISPLAYTRACKREQUEST_BASE_HPP
#define OBJECTS_TRACKMGR_TMGR_DISPLAYTRACKREQUEST_BASE_HPP

// extra headers
#include <objects/trackmgr/trackmgr_export.h>

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CTMgr_AttrSpec;
class CTMgr_ClientInfo;
class CTMgr_GenomeContext;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class NCBI_TRACKMGR_EXPORT CTMgr_DisplayTrackRequest_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CTMgr_DisplayTrackRequest_Base(void);
    // destructor
    virtual ~CTMgr_DisplayTrackRequest_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef CTMgr_ClientInfo TClient;
    typedef list< CRef< CTMgr_GenomeContext > > TGenome_contexts;
    typedef list< CRef< CTMgr_AttrSpec > > TAttrs;

    // getters
    // setters

    /// mandatory
    /// typedef CTMgr_ClientInfo TClient
    ///  Check whether the Client data member has been assigned a value.
    bool IsSetClient(void) const;
    /// Check whether it is safe or not to call GetClient method.
    bool CanGetClient(void) const;
    void ResetClient(void);
    const TClient& GetClient(void) const;
    void SetClient(TClient& value);
    TClient& SetClient(void);

    /// optional
    /// typedef list< CRef< CTMgr_GenomeContext > > TGenome_contexts
    ///  Check whether the Genome_contexts data member has been assigned a value.
    bool IsSetGenome_contexts(void) const;
    /// Check whether it is safe or not to call GetGenome_contexts method.
    bool CanGetGenome_contexts(void) const;
    void ResetGenome_contexts(void);
    const TGenome_contexts& GetGenome_contexts(void) const;
    TGenome_contexts& SetGenome_contexts(void);

    /// optional
    /// typedef list< CRef< CTMgr_AttrSpec > > TAttrs
    ///  Check whether the Attrs data member has been assigned a value.
    bool IsSetAttrs(void) const;
    /// Check whether it is safe or not to call GetAttrs method.
    bool CanGetAttrs(void) const;
    void ResetAttrs(void);
    const TAttrs& GetAttrs(void) const;
    TAttrs& SetAttrs(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CTMgr_DisplayTrackRequest_Base(const CTMgr_DisplayTrackRequest_Base&);
    CTMgr_DisplayTrackRequest_Base& operator=(const CTMgr_DisplayTrackRequest_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TClient > m_Client;
    list< CRef< CTMgr_GenomeContext > > m_Genome_contexts;
    list< CRef< CTMgr_AttrSpec > > m_Attrs;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CTMgr_DisplayTrackRequest_Base::IsSetClient(void) const
{
    return m_Client.NotEmpty();
}

inline
bool CTMgr_DisplayTrackRequest_Base::CanGetClient(void) const
{
    return true;
}

inline
const CTMgr_DisplayTrackRequest_Base::TClient& CTMgr_DisplayTrackRequest_Base::GetClient(void) const
{
    if ( !m_Client ) {
        const_cast<CTMgr_DisplayTrackRequest_Base*>(this)->ResetClient();
    }
    return (*m_Client);
}

inline
CTMgr_DisplayTrackRequest_Base::TClient& CTMgr_DisplayTrackRequest_Base::SetClient(void)
{
    if ( !m_Client ) {
        ResetClient();
    }
    return (*m_Client);
}

inline
bool CTMgr_DisplayTrackRequest_Base::IsSetGenome_contexts(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CTMgr_DisplayTrackRequest_Base::CanGetGenome_contexts(void) const
{
    return true;
}

inline
const CTMgr_DisplayTrackRequest_Base::TGenome_contexts& CTMgr_DisplayTrackRequest_Base::GetGenome_contexts(void) const
{
    return m_Genome_contexts;
}

inline
CTMgr_DisplayTrackRequest_Base::TGenome_contexts& CTMgr_DisplayTrackRequest_Base::SetGenome_contexts(void)
{
    m_set_State[0] |= 0x4;
    return m_Genome_contexts;
}

inline
bool CTMgr_DisplayTrackRequest_Base::IsSetAttrs(void) const
{
    return ((m_set_State[0] & 0x30) != 0);
}

inline
bool CTMgr_DisplayTrackRequest_Base::CanGetAttrs(void) const
{
    return true;
}

inline
const CTMgr_DisplayTrackRequest_Base::TAttrs& CTMgr_DisplayTrackRequest_Base::GetAttrs(void) const
{
    return m_Attrs;
}

inline
CTMgr_DisplayTrackRequest_Base::TAttrs& CTMgr_DisplayTrackRequest_Base::SetAttrs(void)
{
    m_set_State[0] |= 0x10;
    return m_Attrs;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_TRACKMGR_TMGR_DISPLAYTRACKREQUEST_BASE_HPP
