/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file LinkSet.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'elink.dtd'.
///
/// New methods or data members can be added to it if needed.
/// See also: LinkSet_.hpp


#ifndef elink__OBJTOOLS_EUTILS_ELINK_LINKSET_HPP
#define elink__OBJTOOLS_EUTILS_ELINK_LINKSET_HPP


// generated includes
#include <objtools/eutils/elink/LinkSet_.hpp>

// generated classes

BEGIN_elink_SCOPE // namespace elink::

/////////////////////////////////////////////////////////////////////////////
class NCBI_EUTILS_EXPORT CLinkSet : public CLinkSet_Base
{
    typedef CLinkSet_Base Tparent;
public:
    // constructor
    CLinkSet(void);
    // destructor
    ~CLinkSet(void);

private:
    // Prohibit copy constructor and assignment operator
    CLinkSet(const CLinkSet& value);
    CLinkSet& operator=(const CLinkSet& value);

};

/////////////////// CLinkSet inline methods

// constructor
inline
CLinkSet::CLinkSet(void)
{
}


/////////////////// end of CLinkSet inline methods


END_elink_SCOPE // namespace elink::


#endif // elink__OBJTOOLS_EUTILS_ELINK_LINKSET_HPP
/* Original file checksum: lines: 82, chars: 2370, CRC32: b72ae0bd */
