/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file ESummaryResult.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'esummary.dtd'.
///
/// New methods or data members can be added to it if needed.
/// See also: ESummaryResult_.hpp


#ifndef esummary__OBJTOOLS_EUTILS_ESUMMARY_ESUMMARYRESULT_HPP
#define esummary__OBJTOOLS_EUTILS_ESUMMARY_ESUMMARYRESULT_HPP


// generated includes
#include <objtools/eutils/esummary/ESummaryResult_.hpp>

// generated classes

BEGIN_esummary_SCOPE // namespace esummary::

/////////////////////////////////////////////////////////////////////////////
class NCBI_EUTILS_EXPORT CESummaryResult : public CESummaryResult_Base
{
    typedef CESummaryResult_Base Tparent;
public:
    // constructor
    CESummaryResult(void);
    // destructor
    ~CESummaryResult(void);

private:
    // Prohibit copy constructor and assignment operator
    CESummaryResult(const CESummaryResult& value);
    CESummaryResult& operator=(const CESummaryResult& value);

};

/////////////////// CESummaryResult inline methods

// constructor
inline
CESummaryResult::CESummaryResult(void)
{
}


/////////////////// end of CESummaryResult inline methods


END_esummary_SCOPE // namespace esummary::


#endif // esummary__OBJTOOLS_EUTILS_ESUMMARY_ESUMMARYRESULT_HPP
/* Original file checksum: lines: 82, chars: 2539, CRC32: 293fac23 */
