/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file FileName.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'linkout.dtd'.
///
/// New methods or data members can be added to it if needed.
/// See also: FileName_.hpp


#ifndef linkout__OBJTOOLS_EUTILS_LINKOUT_FILENAME_HPP
#define linkout__OBJTOOLS_EUTILS_LINKOUT_FILENAME_HPP


// generated includes
#include <objtools/eutils/linkout/FileName_.hpp>

// generated classes

BEGIN_linkout_SCOPE // namespace linkout::

/////////////////////////////////////////////////////////////////////////////
class NCBI_EUTILS_EXPORT CFileName : public CFileName_Base
{
    typedef CFileName_Base Tparent;
public:
    // constructor
    CFileName(void);
    CFileName(const std::string& value);
    // destructor
    ~CFileName(void);

    /// Conversion operator to 'std::string' type.
    operator const std::string&(void) const;

    /// Assignment operator.
    CFileName& operator=(const std::string& value);

private:
    // Prohibit copy constructor and assignment operator
    CFileName(const CFileName& value);
    CFileName& operator=(const CFileName& value);

};

/////////////////// CFileName inline methods

// constructor
inline
CFileName::CFileName(void)
{
}

inline
CFileName::CFileName(const std::string& value)
{
    SetFileName(value);
}

inline
CFileName::operator const std::string&(void) const
{
    return GetFileName();
}

inline
CFileName& CFileName::operator=(const std::string& value)
{
    SetFileName(value);
    return *this;
}


/////////////////// end of CFileName inline methods


END_linkout_SCOPE // namespace linkout::


#endif // linkout__OBJTOOLS_EUTILS_LINKOUT_FILENAME_HPP
/* Original file checksum: lines: 108, chars: 2891, CRC32: 9bcb332d */
