/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file ObjectSelector_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'linkout.dtd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef linkout__OBJTOOLS_EUTILS_LINKOUT_OBJECTSELECTOR_BASE_HPP
#define linkout__OBJTOOLS_EUTILS_LINKOUT_OBJECTSELECTOR_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <string>

#ifndef BEGIN_linkout_SCOPE
#  define BEGIN_linkout_SCOPE BEGIN_SCOPE(linkout)
#  define END_linkout_SCOPE END_SCOPE(linkout)
#endif
BEGIN_linkout_SCOPE // namespace linkout::


// forward declarations
class CObjectList;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class NCBI_EUTILS_EXPORT CObjectSelector_Base : public NCBI_NS_NCBI::CSerialObject
{
    typedef NCBI_NS_NCBI::CSerialObject Tparent;
public:
    // constructor
    CObjectSelector_Base(void);
    // destructor
    virtual ~CObjectSelector_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef NCBI_NS_STD::string TDatabase;
    typedef CObjectList TObjectList;

    // getters
    // setters

    /// mandatory
    /// typedef NCBI_NS_STD::string TDatabase
    ///  Check whether the Database data member has been assigned a value.
    bool IsSetDatabase(void) const;
    /// Check whether it is safe or not to call GetDatabase method.
    bool CanGetDatabase(void) const;
    void ResetDatabase(void);
    const TDatabase& GetDatabase(void) const;
    void SetDatabase(const TDatabase& value);
    TDatabase& SetDatabase(void);

    /// All Entrez databases may be configured to include LinkOut.  Please write to
    ///linkout@ncbi.nlm.nih.gov for the current list of databases available for LinkOut 
    /// mandatory
    /// typedef CObjectList TObjectList
    ///  Check whether the ObjectList data member has been assigned a value.
    bool IsSetObjectList(void) const;
    /// Check whether it is safe or not to call GetObjectList method.
    bool CanGetObjectList(void) const;
    void ResetObjectList(void);
    const TObjectList& GetObjectList(void) const;
    void SetObjectList(TObjectList& value);
    TObjectList& SetObjectList(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CObjectSelector_Base(const CObjectSelector_Base&);
    CObjectSelector_Base& operator=(const CObjectSelector_Base&);

    // data
    Uint4 m_set_State[1];
    NCBI_NS_STD::string m_Database;
    NCBI_NS_NCBI::CRef< TObjectList > m_ObjectList;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CObjectSelector_Base::IsSetDatabase(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CObjectSelector_Base::CanGetDatabase(void) const
{
    return IsSetDatabase();
}

inline
const CObjectSelector_Base::TDatabase& CObjectSelector_Base::GetDatabase(void) const
{
    if (!CanGetDatabase()) {
        ThrowUnassigned(0);
    }
    return m_Database;
}

inline
void CObjectSelector_Base::SetDatabase(const CObjectSelector_Base::TDatabase& value)
{
    m_Database = value;
    m_set_State[0] |= 0x3;
}

inline
CObjectSelector_Base::TDatabase& CObjectSelector_Base::SetDatabase(void)
{
#ifdef _DEBUG
    if (!IsSetDatabase()) {
        m_Database = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Database;
}

inline
bool CObjectSelector_Base::IsSetObjectList(void) const
{
    return m_ObjectList.NotEmpty();
}

inline
bool CObjectSelector_Base::CanGetObjectList(void) const
{
    return true;
}

inline
const CObjectSelector_Base::TObjectList& CObjectSelector_Base::GetObjectList(void) const
{
    if ( !m_ObjectList ) {
        const_cast<CObjectSelector_Base*>(this)->ResetObjectList();
    }
    return (*m_ObjectList);
}

inline
CObjectSelector_Base::TObjectList& CObjectSelector_Base::SetObjectList(void)
{
    if ( !m_ObjectList ) {
        ResetObjectList();
    }
    return (*m_ObjectList);
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_linkout_SCOPE // namespace linkout::


#endif // linkout__OBJTOOLS_EUTILS_LINKOUT_OBJECTSELECTOR_BASE_HPP
