/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file SubObjectSelector_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'linkout.dtd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef linkout__OBJTOOLS_EUTILS_LINKOUT_SUBOBJECTSELECTOR_BASE_HPP
#define linkout__OBJTOOLS_EUTILS_LINKOUT_SUBOBJECTSELECTOR_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <string>

#ifndef BEGIN_linkout_SCOPE
#  define BEGIN_linkout_SCOPE BEGIN_SCOPE(linkout)
#  define END_linkout_SCOPE END_SCOPE(linkout)
#endif
BEGIN_linkout_SCOPE // namespace linkout::


// forward declarations
class CSubProvider;


// generated classes

/////////////////////////////////////////////////////////////////////////////
/// End of ObjectList group 
/// End of ObjectSelector group 
/// Libraries must use SubObjectSelector to refer to the sub providers 
class NCBI_EUTILS_EXPORT CSubObjectSelector_Base : public NCBI_NS_NCBI::CSerialObject
{
    typedef NCBI_NS_NCBI::CSerialObject Tparent;
public:
    // constructor
    CSubObjectSelector_Base(void);
    // destructor
    virtual ~CSubObjectSelector_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef NCBI_NS_STD::string TDatabase;
    typedef CSubProvider TSubProvider;

    // getters
    // setters

    /// mandatory
    /// typedef NCBI_NS_STD::string TDatabase
    ///  Check whether the Database data member has been assigned a value.
    bool IsSetDatabase(void) const;
    /// Check whether it is safe or not to call GetDatabase method.
    bool CanGetDatabase(void) const;
    void ResetDatabase(void);
    const TDatabase& GetDatabase(void) const;
    void SetDatabase(const TDatabase& value);
    TDatabase& SetDatabase(void);

    /// mandatory
    /// typedef CSubProvider TSubProvider
    ///  Check whether the SubProvider data member has been assigned a value.
    bool IsSetSubProvider(void) const;
    /// Check whether it is safe or not to call GetSubProvider method.
    bool CanGetSubProvider(void) const;
    void ResetSubProvider(void);
    const TSubProvider& GetSubProvider(void) const;
    void SetSubProvider(TSubProvider& value);
    TSubProvider& SetSubProvider(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CSubObjectSelector_Base(const CSubObjectSelector_Base&);
    CSubObjectSelector_Base& operator=(const CSubObjectSelector_Base&);

    // data
    Uint4 m_set_State[1];
    NCBI_NS_STD::string m_Database;
    NCBI_NS_NCBI::CRef< TSubProvider > m_SubProvider;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CSubObjectSelector_Base::IsSetDatabase(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CSubObjectSelector_Base::CanGetDatabase(void) const
{
    return IsSetDatabase();
}

inline
const CSubObjectSelector_Base::TDatabase& CSubObjectSelector_Base::GetDatabase(void) const
{
    if (!CanGetDatabase()) {
        ThrowUnassigned(0);
    }
    return m_Database;
}

inline
void CSubObjectSelector_Base::SetDatabase(const CSubObjectSelector_Base::TDatabase& value)
{
    m_Database = value;
    m_set_State[0] |= 0x3;
}

inline
CSubObjectSelector_Base::TDatabase& CSubObjectSelector_Base::SetDatabase(void)
{
#ifdef _DEBUG
    if (!IsSetDatabase()) {
        m_Database = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Database;
}

inline
bool CSubObjectSelector_Base::IsSetSubProvider(void) const
{
    return m_SubProvider.NotEmpty();
}

inline
bool CSubObjectSelector_Base::CanGetSubProvider(void) const
{
    return true;
}

inline
const CSubObjectSelector_Base::TSubProvider& CSubObjectSelector_Base::GetSubProvider(void) const
{
    if ( !m_SubProvider ) {
        const_cast<CSubObjectSelector_Base*>(this)->ResetSubProvider();
    }
    return (*m_SubProvider);
}

inline
CSubObjectSelector_Base::TSubProvider& CSubObjectSelector_Base::SetSubProvider(void)
{
    if ( !m_SubProvider ) {
        ResetSubProvider();
    }
    return (*m_SubProvider);
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_linkout_SCOPE // namespace linkout::


#endif // linkout__OBJTOOLS_EUTILS_LINKOUT_SUBOBJECTSELECTOR_BASE_HPP
