/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Db_Clipboard_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'we_cpp.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef SERIAL_TEST_DB_CLIPBOARD_BASE_HPP
#define SERIAL_TEST_DB_CLIPBOARD_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <string>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CItem_Set;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class CDb_Clipboard_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CDb_Clipboard_Base(void);
    // destructor
    virtual ~CDb_Clipboard_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef string TName;
    typedef int TCount;
    typedef CItem_Set TItems;

    // getters
    // setters

    /// clipboard name
    /// mandatory
    /// typedef string TName
    ///  Check whether the Name data member has been assigned a value.
    bool IsSetName(void) const;
    /// Check whether it is safe or not to call GetName method.
    bool CanGetName(void) const;
    void ResetName(void);
    const TName& GetName(void) const;
    void SetName(const TName& value);
    TName& SetName(void);

    /// cached count of items
    /// mandatory
    /// typedef int TCount
    ///  Check whether the Count data member has been assigned a value.
    bool IsSetCount(void) const;
    /// Check whether it is safe or not to call GetCount method.
    bool CanGetCount(void) const;
    void ResetCount(void);
    TCount GetCount(void) const;
    void SetCount(TCount value);
    TCount& SetCount(void);

    /// id
    /// mandatory
    /// typedef CItem_Set TItems
    ///  Check whether the Items data member has been assigned a value.
    bool IsSetItems(void) const;
    /// Check whether it is safe or not to call GetItems method.
    bool CanGetItems(void) const;
    void ResetItems(void);
    const TItems& GetItems(void) const;
    void SetItems(TItems& value);
    TItems& SetItems(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CDb_Clipboard_Base(const CDb_Clipboard_Base&);
    CDb_Clipboard_Base& operator=(const CDb_Clipboard_Base&);

    // data
    Uint4 m_set_State[1];
    string m_Name;
    int m_Count;
    CRef< TItems > m_Items;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CDb_Clipboard_Base::IsSetName(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CDb_Clipboard_Base::CanGetName(void) const
{
    return IsSetName();
}

inline
const CDb_Clipboard_Base::TName& CDb_Clipboard_Base::GetName(void) const
{
    if (!CanGetName()) {
        ThrowUnassigned(0);
    }
    return m_Name;
}

inline
void CDb_Clipboard_Base::SetName(const CDb_Clipboard_Base::TName& value)
{
    m_Name = value;
    m_set_State[0] |= 0x3;
}

inline
CDb_Clipboard_Base::TName& CDb_Clipboard_Base::SetName(void)
{
#ifdef _DEBUG
    if (!IsSetName()) {
        m_Name = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Name;
}

inline
bool CDb_Clipboard_Base::IsSetCount(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CDb_Clipboard_Base::CanGetCount(void) const
{
    return IsSetCount();
}

inline
void CDb_Clipboard_Base::ResetCount(void)
{
    m_Count = 0;
    m_set_State[0] &= ~0xc;
}

inline
CDb_Clipboard_Base::TCount CDb_Clipboard_Base::GetCount(void) const
{
    if (!CanGetCount()) {
        ThrowUnassigned(1);
    }
    return m_Count;
}

inline
void CDb_Clipboard_Base::SetCount(CDb_Clipboard_Base::TCount value)
{
    m_Count = value;
    m_set_State[0] |= 0xc;
}

inline
CDb_Clipboard_Base::TCount& CDb_Clipboard_Base::SetCount(void)
{
#ifdef _DEBUG
    if (!IsSetCount()) {
        memset(&m_Count,UnassignedByte(),sizeof(m_Count));
    }
#endif
    m_set_State[0] |= 0x4;
    return m_Count;
}

inline
bool CDb_Clipboard_Base::IsSetItems(void) const
{
    return m_Items.NotEmpty();
}

inline
bool CDb_Clipboard_Base::CanGetItems(void) const
{
    return true;
}

inline
const CDb_Clipboard_Base::TItems& CDb_Clipboard_Base::GetItems(void) const
{
    if ( !m_Items ) {
        const_cast<CDb_Clipboard_Base*>(this)->ResetItems();
    }
    return (*m_Items);
}

inline
CDb_Clipboard_Base::TItems& CDb_Clipboard_Base::SetItems(void)
{
    if ( !m_Items ) {
        ResetItems();
    }
    return (*m_Items);
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // SERIAL_TEST_DB_CLIPBOARD_BASE_HPP
