/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Db_Env_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'we_cpp.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef SERIAL_TEST_DB_ENV_BASE_HPP
#define SERIAL_TEST_DB_ENV_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>
#include <string>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CArgument;
class CDb_Clipboard;
class CFilter_Value;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class CDb_Env_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CDb_Env_Base(void);
    // destructor
    virtual ~CDb_Env_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef string TName;
    typedef list< CRef< CArgument > > TArguments;
    typedef list< CRef< CFilter_Value > > TFilters;
    typedef list< CRef< CDb_Clipboard > > TClipboard;

    // getters
    // setters

    /// name of DB
    /// mandatory
    /// typedef string TName
    ///  Check whether the Name data member has been assigned a value.
    bool IsSetName(void) const;
    /// Check whether it is safe or not to call GetName method.
    bool CanGetName(void) const;
    void ResetName(void);
    const TName& GetName(void) const;
    void SetName(const TName& value);
    TName& SetName(void);

    /// variable arguments
    /// optional
    /// typedef list< CRef< CArgument > > TArguments
    ///  Check whether the Arguments data member has been assigned a value.
    bool IsSetArguments(void) const;
    /// Check whether it is safe or not to call GetArguments method.
    bool CanGetArguments(void) const;
    void ResetArguments(void);
    const TArguments& GetArguments(void) const;
    TArguments& SetArguments(void);

    /// current filters set
    /// optional
    /// typedef list< CRef< CFilter_Value > > TFilters
    ///  Check whether the Filters data member has been assigned a value.
    bool IsSetFilters(void) const;
    /// Check whether it is safe or not to call GetFilters method.
    bool CanGetFilters(void) const;
    void ResetFilters(void);
    const TFilters& GetFilters(void) const;
    TFilters& SetFilters(void);

    /// db's clipboards (one for query WebEnv)
    /// optional
    /// typedef list< CRef< CDb_Clipboard > > TClipboard
    ///  Check whether the Clipboard data member has been assigned a value.
    bool IsSetClipboard(void) const;
    /// Check whether it is safe or not to call GetClipboard method.
    bool CanGetClipboard(void) const;
    void ResetClipboard(void);
    const TClipboard& GetClipboard(void) const;
    TClipboard& SetClipboard(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CDb_Env_Base(const CDb_Env_Base&);
    CDb_Env_Base& operator=(const CDb_Env_Base&);

    // data
    Uint4 m_set_State[1];
    string m_Name;
    list< CRef< CArgument > > m_Arguments;
    list< CRef< CFilter_Value > > m_Filters;
    list< CRef< CDb_Clipboard > > m_Clipboard;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CDb_Env_Base::IsSetName(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CDb_Env_Base::CanGetName(void) const
{
    return IsSetName();
}

inline
const CDb_Env_Base::TName& CDb_Env_Base::GetName(void) const
{
    if (!CanGetName()) {
        ThrowUnassigned(0);
    }
    return m_Name;
}

inline
void CDb_Env_Base::SetName(const CDb_Env_Base::TName& value)
{
    m_Name = value;
    m_set_State[0] |= 0x3;
}

inline
CDb_Env_Base::TName& CDb_Env_Base::SetName(void)
{
#ifdef _DEBUG
    if (!IsSetName()) {
        m_Name = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Name;
}

inline
bool CDb_Env_Base::IsSetArguments(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CDb_Env_Base::CanGetArguments(void) const
{
    return true;
}

inline
const CDb_Env_Base::TArguments& CDb_Env_Base::GetArguments(void) const
{
    return m_Arguments;
}

inline
CDb_Env_Base::TArguments& CDb_Env_Base::SetArguments(void)
{
    m_set_State[0] |= 0x4;
    return m_Arguments;
}

inline
bool CDb_Env_Base::IsSetFilters(void) const
{
    return ((m_set_State[0] & 0x30) != 0);
}

inline
bool CDb_Env_Base::CanGetFilters(void) const
{
    return true;
}

inline
const CDb_Env_Base::TFilters& CDb_Env_Base::GetFilters(void) const
{
    return m_Filters;
}

inline
CDb_Env_Base::TFilters& CDb_Env_Base::SetFilters(void)
{
    m_set_State[0] |= 0x10;
    return m_Filters;
}

inline
bool CDb_Env_Base::IsSetClipboard(void) const
{
    return ((m_set_State[0] & 0xc0) != 0);
}

inline
bool CDb_Env_Base::CanGetClipboard(void) const
{
    return true;
}

inline
const CDb_Env_Base::TClipboard& CDb_Env_Base::GetClipboard(void) const
{
    return m_Clipboard;
}

inline
CDb_Env_Base::TClipboard& CDb_Env_Base::SetClipboard(void)
{
    m_set_State[0] |= 0x40;
    return m_Clipboard;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // SERIAL_TEST_DB_ENV_BASE_HPP
