/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Item_Set_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'we_cpp.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef SERIAL_TEST_ITEM_SET_BASE_HPP
#define SERIAL_TEST_ITEM_SET_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <vector>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
class CItem_Set_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CItem_Set_Base(void);
    // destructor
    virtual ~CItem_Set_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef vector< char > TItems;
    typedef int TCount;

    // getters
    // setters

    /// IDs of items
    /// mandatory
    /// typedef vector< char > TItems
    ///  Check whether the Items data member has been assigned a value.
    bool IsSetItems(void) const;
    /// Check whether it is safe or not to call GetItems method.
    bool CanGetItems(void) const;
    void ResetItems(void);
    const TItems& GetItems(void) const;
    TItems& SetItems(void);

    /// cached count of items
    /// mandatory
    /// typedef int TCount
    ///  Check whether the Count data member has been assigned a value.
    bool IsSetCount(void) const;
    /// Check whether it is safe or not to call GetCount method.
    bool CanGetCount(void) const;
    void ResetCount(void);
    TCount GetCount(void) const;
    void SetCount(TCount value);
    TCount& SetCount(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CItem_Set_Base(const CItem_Set_Base&);
    CItem_Set_Base& operator=(const CItem_Set_Base&);

    // data
    Uint4 m_set_State[1];
    vector< char > m_Items;
    int m_Count;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CItem_Set_Base::IsSetItems(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CItem_Set_Base::CanGetItems(void) const
{
    return IsSetItems();
}

inline
const CItem_Set_Base::TItems& CItem_Set_Base::GetItems(void) const
{
    if (!CanGetItems()) {
        ThrowUnassigned(0);
    }
    return m_Items;
}

inline
CItem_Set_Base::TItems& CItem_Set_Base::SetItems(void)
{
    m_set_State[0] |= 0x1;
    return m_Items;
}

inline
bool CItem_Set_Base::IsSetCount(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CItem_Set_Base::CanGetCount(void) const
{
    return IsSetCount();
}

inline
void CItem_Set_Base::ResetCount(void)
{
    m_Count = 0;
    m_set_State[0] &= ~0xc;
}

inline
CItem_Set_Base::TCount CItem_Set_Base::GetCount(void) const
{
    if (!CanGetCount()) {
        ThrowUnassigned(1);
    }
    return m_Count;
}

inline
void CItem_Set_Base::SetCount(CItem_Set_Base::TCount value)
{
    m_Count = value;
    m_set_State[0] |= 0xc;
}

inline
CItem_Set_Base::TCount& CItem_Set_Base::SetCount(void)
{
#ifdef _DEBUG
    if (!IsSetCount()) {
        memset(&m_Count,UnassignedByte(),sizeof(m_Count));
    }
#endif
    m_set_State[0] |= 0x4;
    return m_Count;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // SERIAL_TEST_ITEM_SET_BASE_HPP
