/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Query_History_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'we_cpp.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef SERIAL_TEST_QUERY_HISTORY_BASE_HPP
#define SERIAL_TEST_QUERY_HISTORY_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <string>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CQuery_Command;
class CTime;


// generated classes

/////////////////////////////////////////////////////////////////////////////
/// Queries history information
class CQuery_History_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CQuery_History_Base(void);
    // destructor
    virtual ~CQuery_History_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef string TName;
    typedef int TSeqNumber;
    typedef CTime TTime;
    typedef CQuery_Command TCommand;

    // getters
    // setters

    /// name of this query (may be empty)
    /// optional
    /// typedef string TName
    ///  Check whether the Name data member has been assigned a value.
    bool IsSetName(void) const;
    /// Check whether it is safe or not to call GetName method.
    bool CanGetName(void) const;
    void ResetName(void);
    const TName& GetName(void) const;
    void SetName(const TName& value);
    TName& SetName(void);

    /// sequential number of this query
    /// mandatory
    /// typedef int TSeqNumber
    ///  Check whether the SeqNumber data member has been assigned a value.
    bool IsSetSeqNumber(void) const;
    /// Check whether it is safe or not to call GetSeqNumber method.
    bool CanGetSeqNumber(void) const;
    void ResetSeqNumber(void);
    TSeqNumber GetSeqNumber(void) const;
    void SetSeqNumber(TSeqNumber value);
    TSeqNumber& SetSeqNumber(void);

    /// time of query execution
    /// mandatory
    /// typedef CTime TTime
    ///  Check whether the Time data member has been assigned a value.
    bool IsSetTime(void) const;
    /// Check whether it is safe or not to call GetTime method.
    bool CanGetTime(void) const;
    void ResetTime(void);
    const TTime& GetTime(void) const;
    void SetTime(TTime& value);
    TTime& SetTime(void);

    /// query command
    /// mandatory
    /// typedef CQuery_Command TCommand
    ///  Check whether the Command data member has been assigned a value.
    bool IsSetCommand(void) const;
    /// Check whether it is safe or not to call GetCommand method.
    bool CanGetCommand(void) const;
    void ResetCommand(void);
    const TCommand& GetCommand(void) const;
    void SetCommand(TCommand& value);
    TCommand& SetCommand(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CQuery_History_Base(const CQuery_History_Base&);
    CQuery_History_Base& operator=(const CQuery_History_Base&);

    // data
    Uint4 m_set_State[1];
    string m_Name;
    int m_SeqNumber;
    CRef< TTime > m_Time;
    CRef< TCommand > m_Command;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CQuery_History_Base::IsSetName(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CQuery_History_Base::CanGetName(void) const
{
    return IsSetName();
}

inline
const CQuery_History_Base::TName& CQuery_History_Base::GetName(void) const
{
    if (!CanGetName()) {
        ThrowUnassigned(0);
    }
    return m_Name;
}

inline
void CQuery_History_Base::SetName(const CQuery_History_Base::TName& value)
{
    m_Name = value;
    m_set_State[0] |= 0x3;
}

inline
CQuery_History_Base::TName& CQuery_History_Base::SetName(void)
{
#ifdef _DEBUG
    if (!IsSetName()) {
        m_Name = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Name;
}

inline
bool CQuery_History_Base::IsSetSeqNumber(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CQuery_History_Base::CanGetSeqNumber(void) const
{
    return IsSetSeqNumber();
}

inline
void CQuery_History_Base::ResetSeqNumber(void)
{
    m_SeqNumber = 0;
    m_set_State[0] &= ~0xc;
}

inline
CQuery_History_Base::TSeqNumber CQuery_History_Base::GetSeqNumber(void) const
{
    if (!CanGetSeqNumber()) {
        ThrowUnassigned(1);
    }
    return m_SeqNumber;
}

inline
void CQuery_History_Base::SetSeqNumber(CQuery_History_Base::TSeqNumber value)
{
    m_SeqNumber = value;
    m_set_State[0] |= 0xc;
}

inline
CQuery_History_Base::TSeqNumber& CQuery_History_Base::SetSeqNumber(void)
{
#ifdef _DEBUG
    if (!IsSetSeqNumber()) {
        memset(&m_SeqNumber,UnassignedByte(),sizeof(m_SeqNumber));
    }
#endif
    m_set_State[0] |= 0x4;
    return m_SeqNumber;
}

inline
bool CQuery_History_Base::IsSetTime(void) const
{
    return m_Time.NotEmpty();
}

inline
bool CQuery_History_Base::CanGetTime(void) const
{
    return true;
}

inline
const CQuery_History_Base::TTime& CQuery_History_Base::GetTime(void) const
{
    if ( !m_Time ) {
        const_cast<CQuery_History_Base*>(this)->ResetTime();
    }
    return (*m_Time);
}

inline
CQuery_History_Base::TTime& CQuery_History_Base::SetTime(void)
{
    if ( !m_Time ) {
        ResetTime();
    }
    return (*m_Time);
}

inline
bool CQuery_History_Base::IsSetCommand(void) const
{
    return m_Command.NotEmpty();
}

inline
bool CQuery_History_Base::CanGetCommand(void) const
{
    return true;
}

inline
const CQuery_History_Base::TCommand& CQuery_History_Base::GetCommand(void) const
{
    if ( !m_Command ) {
        const_cast<CQuery_History_Base*>(this)->ResetCommand();
    }
    return (*m_Command);
}

inline
CQuery_History_Base::TCommand& CQuery_History_Base::SetCommand(void)
{
    if ( !m_Command ) {
        ResetCommand();
    }
    return (*m_Command);
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // SERIAL_TEST_QUERY_HISTORY_BASE_HPP
