/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Web_Env_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'we_cpp.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef SERIAL_TEST_WEB_ENV_BASE_HPP
#define SERIAL_TEST_WEB_ENV_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CArgument;
class CDb_Env;
class CQuery_History;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class CWeb_Env_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CWeb_Env_Base(void);
    // destructor
    virtual ~CWeb_Env_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef list< CRef< CArgument > > TArguments;
    typedef list< CRef< CDb_Env > > TDb_Env;
    typedef list< CRef< CQuery_History > > TQueries;

    // getters
    // setters

    /// variable arguments
    /// optional
    /// typedef list< CRef< CArgument > > TArguments
    ///  Check whether the Arguments data member has been assigned a value.
    bool IsSetArguments(void) const;
    /// Check whether it is safe or not to call GetArguments method.
    bool CanGetArguments(void) const;
    void ResetArguments(void);
    const TArguments& GetArguments(void) const;
    TArguments& SetArguments(void);

    /// list of DB environments
    /// optional
    /// typedef list< CRef< CDb_Env > > TDb_Env
    ///  Check whether the Db_Env data member has been assigned a value.
    bool IsSetDb_Env(void) const;
    /// Check whether it is safe or not to call GetDb_Env method.
    bool CanGetDb_Env(void) const;
    void ResetDb_Env(void);
    const TDb_Env& GetDb_Env(void) const;
    TDb_Env& SetDb_Env(void);

    /// history of queries
    /// optional
    /// typedef list< CRef< CQuery_History > > TQueries
    ///  Check whether the Queries data member has been assigned a value.
    bool IsSetQueries(void) const;
    /// Check whether it is safe or not to call GetQueries method.
    bool CanGetQueries(void) const;
    void ResetQueries(void);
    const TQueries& GetQueries(void) const;
    TQueries& SetQueries(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CWeb_Env_Base(const CWeb_Env_Base&);
    CWeb_Env_Base& operator=(const CWeb_Env_Base&);

    // data
    Uint4 m_set_State[1];
    list< CRef< CArgument > > m_Arguments;
    list< CRef< CDb_Env > > m_Db_Env;
    list< CRef< CQuery_History > > m_Queries;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CWeb_Env_Base::IsSetArguments(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CWeb_Env_Base::CanGetArguments(void) const
{
    return true;
}

inline
const CWeb_Env_Base::TArguments& CWeb_Env_Base::GetArguments(void) const
{
    return m_Arguments;
}

inline
CWeb_Env_Base::TArguments& CWeb_Env_Base::SetArguments(void)
{
    m_set_State[0] |= 0x1;
    return m_Arguments;
}

inline
bool CWeb_Env_Base::IsSetDb_Env(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CWeb_Env_Base::CanGetDb_Env(void) const
{
    return true;
}

inline
const CWeb_Env_Base::TDb_Env& CWeb_Env_Base::GetDb_Env(void) const
{
    return m_Db_Env;
}

inline
CWeb_Env_Base::TDb_Env& CWeb_Env_Base::SetDb_Env(void)
{
    m_set_State[0] |= 0x4;
    return m_Db_Env;
}

inline
bool CWeb_Env_Base::IsSetQueries(void) const
{
    return ((m_set_State[0] & 0x30) != 0);
}

inline
bool CWeb_Env_Base::CanGetQueries(void) const
{
    return true;
}

inline
const CWeb_Env_Base::TQueries& CWeb_Env_Base::GetQueries(void) const
{
    return m_Queries;
}

inline
CWeb_Env_Base::TQueries& CWeb_Env_Base::SetQueries(void)
{
    m_set_State[0] |= 0x10;
    return m_Queries;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // SERIAL_TEST_WEB_ENV_BASE_HPP
