/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Web_Saved_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'we_cpp.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef SERIAL_TEST_WEB_SAVED_BASE_HPP
#define SERIAL_TEST_WEB_SAVED_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CNamed_Item_Set;
class CNamed_Query;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class CWeb_Saved_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CWeb_Saved_Base(void);
    // destructor
    virtual ~CWeb_Saved_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef list< CRef< CNamed_Query > > TQueries;
    typedef list< CRef< CNamed_Item_Set > > TItem_Sets;

    // getters
    // setters

    /// optional
    /// typedef list< CRef< CNamed_Query > > TQueries
    ///  Check whether the Queries data member has been assigned a value.
    bool IsSetQueries(void) const;
    /// Check whether it is safe or not to call GetQueries method.
    bool CanGetQueries(void) const;
    void ResetQueries(void);
    const TQueries& GetQueries(void) const;
    TQueries& SetQueries(void);

    /// optional
    /// typedef list< CRef< CNamed_Item_Set > > TItem_Sets
    ///  Check whether the Item_Sets data member has been assigned a value.
    bool IsSetItem_Sets(void) const;
    /// Check whether it is safe or not to call GetItem_Sets method.
    bool CanGetItem_Sets(void) const;
    void ResetItem_Sets(void);
    const TItem_Sets& GetItem_Sets(void) const;
    TItem_Sets& SetItem_Sets(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CWeb_Saved_Base(const CWeb_Saved_Base&);
    CWeb_Saved_Base& operator=(const CWeb_Saved_Base&);

    // data
    Uint4 m_set_State[1];
    list< CRef< CNamed_Query > > m_Queries;
    list< CRef< CNamed_Item_Set > > m_Item_Sets;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CWeb_Saved_Base::IsSetQueries(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CWeb_Saved_Base::CanGetQueries(void) const
{
    return true;
}

inline
const CWeb_Saved_Base::TQueries& CWeb_Saved_Base::GetQueries(void) const
{
    return m_Queries;
}

inline
CWeb_Saved_Base::TQueries& CWeb_Saved_Base::SetQueries(void)
{
    m_set_State[0] |= 0x1;
    return m_Queries;
}

inline
bool CWeb_Saved_Base::IsSetItem_Sets(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CWeb_Saved_Base::CanGetItem_Sets(void) const
{
    return true;
}

inline
const CWeb_Saved_Base::TItem_Sets& CWeb_Saved_Base::GetItem_Sets(void) const
{
    return m_Item_Sets;
}

inline
CWeb_Saved_Base::TItem_Sets& CWeb_Saved_Base::SetItem_Sets(void)
{
    m_set_State[0] |= 0x4;
    return m_Item_Sets;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // SERIAL_TEST_WEB_SAVED_BASE_HPP
